'V 25/06/07

'the absolute minimum time for 400 steps is 2 seconds 
'Scottys sweeps 400 steps in 10 seconds
'This program sweeps 400 steps in 17 seconds
'Frank mod February, March, April  2007
'added [logData10Bit_PIC] subroutine to read MAGnitude and PHAse data from PIC 18F4550 ADC modules

' S E R I A L   C o n t r o l          March/October 2007
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
global OneMicroSecondSTEPS'Variable used in Pause routine
Dbug=0'		0=debug OFF		1=debug ON for control variable dumps,    3- debug ON for for ADC dumps       
PICRUN=1	'PICRUN=0 --> NOPIC, PICRUN=1 --> PIC attached



nomainwin
dim parm$(20)' Specify that up to 20 parameters can be sent to the PIC

SERIALdelay=10'Delay between parms written to PIC to prevent overrun error (3uS is the lower limit to prevent over runs)		


PICcom$="com3"'SPECIFY the COM port used by your system (check with Device Manager)

if PICRUN=1 then gosub [OpenCOM]
'if Dbug = 1 then input "returned from sub OpenCom ";xx$

vna=0' Turn VNA OFF at start VNA mode NOT available on startup

'
'10-17-06 version110
'This version is updated from version 108.  For both MSA and VNA.

            'all of the following are "default" values and are dependent on the construction of your Spectrum Analyzer


    masterclock = 64    'enter the exact frequency of the Master Clock (in MHz).  Example: 64.000056 or 63.999937
      'if exact frequency is unknown, enter the nominal value of Master Clock.  Example: 64.  You can chage it when calibrating.
    centfreq = 0'450'20'0.2'450'30'10.7 '200     'enter the default center frequency, in MHz. For initial set-up use "0"
    sweepwidth =0.1    'enter the default sweep width, in MHz. For initial set-up use 10 times the BW of Final Xtal Filter
    wate = 0            'value to "slow" the sweep speed for more accurate data.  Use "0" as default.
    steps = 400         'whole number of steps per sweep. 1 thru 720 is acceptable.  400 is a good number.
    marker1 = 100       'marker 1 step placement, default.  A marker will be placed on the graph, at this step number
    marker2 = 200       'marker 2 step placement, default.  If no markers are wanted, enter the value, 750, in each marker default
    marker3 = 300       'marker 3 step placement, default. If the value is greater than "steps", no marker will display
    finalfreq1 = 10.695'10.7   'freq of Final Xtal Filter # 1, in MHz
    finalbw1 = 7.5'3 '10.0      'BW (in KHz)of Final Xtal Filter # 1
    sagain1 = 0         'total gain of SA with Final Filter #1 installed
    finalfreq2 = 10.7   'freq of Final Xtal Filter # 2, in MHz.  If only Final Xtal Filter # 1 is used, enter duplicate values.
    finalbw2 = 15       'BW (in KHz)of Final Xtal Filter # 2
    sagain2 = 0         'total gain of SA with Final Filter #2 installed
    finalfreq3 = 10.7   'freq of Final Xtal Filter # 3, in MHz
    finalbw3 = 30       'BW (in KHz)of Final Xtal Filter # 3
    sagain3 = 0         'total gain of SA with Final Filter #3 installed
    finalfreq4 = 10.7   'freq of Final Xtal Filter # 4, in MHz
    finalbw4 = 300      'BW (in KHz)of Final Xtal Filter # 4
    sagain4 = 0         'total gain of SA with Final Filter #4 installed
    '---DDS
    appxDDS = 10.702      'this is the nominal DDS output frequency (in MHz) that steers PLL 1, must be the center freq. of DDS xtal filter
    ddsfilbw = 0.01'.015     'this is the DDS xtal filter bandwidth (3 dB points)
    '--PLL1
    PLL1 = 2326         'enter PLL #: 2325, 2326, 2350, 2353, 4112
    PLL1phasefreq = .974   'approximate Phase Detector Frequency (MHz) you want for PLL 1. Use .974 when DDS filter is 15 KHz wide
    'PLL1phasefreq must be less than the following formula: PLL1phasefreq < (VCO 1 minimum frequency) x ddsfilbw/appxDDS (=1.42 ?? as specified)
    
    PLL1mode = 0        '0 = Integer Mode, 1 = Fractional Mode for PLL 1.  I don't recommend Fractional Mode for PLL 1, although it will work (noiser)
    PLL1phasepolarity = 0  'for non-inverting loop filter, enter 1; for inverting op amp, enter 0
    
    '--PLL2
    PLL2 = 2326         'enter PLL #: 2325, 2326, 2350, 2353, 4112, or 0 for SRD multiplier
    appxLO2 = 1024      '2nd LO frequency (MHz). 1024 is nominal, Must be a whole number multiple of "PLL2phasefreq"
    PLL2phasefreq = 4   'PLL2 phase frequency (MHz).  This must be a numerical sub-multiple of "appxLO2". 4 is nominal
    PLL2phasepolarity = 1  'for non-inverting loop filter, enter 1; for inverting op amp, enter 0
    
'----------------------------------------------------------------------------------------------------------------------------    
    PLL3 = 2326         'enter PLL #: 2325, 2326, 2350, 2353, 4112. Enter "0" (zero) for no Tracking Generator. 2350 and 2353 can be used as fractional-N
    PLL3phasepolarity = 1  'enter 1 for non-inverting loop filter; for inverting op amp, enter 0
    PLL3off =1013.3'1024'970       'Output freq of PLL3/VCO3 when Trk Gen "off", in MHz
'----------------------------------    
    PLL3top = 0         'PLL3 Topology. Enter "0" for original Trk Gen. Enter "1" for New TG (DDS3/PLL3 combination)
'-----------------------------------    
    PLL3mode = 0        '1 = Fractional Mode, 0 = Integer Mode. If fractional mode is used, the step size is "PLL3phasefreq"/16
        'if Original TG is used, PLL3mode can be "0" or "1".  Enter "0" for new DDS/PLL combo. It must Integer-N
    PLL3phasefreq = 0.005'0.5'0.05'0.01'0.005'.974    'TrkGen PLL3 phase frequency (MHz). If TG is DDS3/PLL3 combo, use same technique as PLL1phasefreq
                          'if Original TG (PLL3top=0) then this must be a sub-multiple of both Master Clock and Final Xtal Filter Frequency
    appxDDS3 = 0'10.7     'Nominal DDS3 output frequency (in MHz) that steers PLL 3 (center freq of DDS 3 filter)
                            'Enter "0" if using original Tracking Generator design
    dds3filbw = .015    'this is the DDS3 xtal filter bandwidth (3 dB points), in MHz
    PLL3offset = 0      'Enter "0" (Mhz). This is offset frequency for PLL 3, Tracking Generator, but not tested yet
    glitchtime = 5000   'this is whole numer value that is added to the [Settle Down] when the DDS or PLL changes drastically
    topref = 10          'default, top reference line on scale, magnitude, in dBm input to MSA. For initial set-up, use "0"
    botref = -90       'default bottom reference line on scale, magnitude, in dBm input to MSA. For initial set-up, use "-100"
    '[CalibrationFile]  'change following variables for your Log Det/AtoD combination
    adconv = 10         '"8" for original 8 bit, "10" for PIC ADC, "12" for optional 12 bit ladder,or "16" for serial AtoD
    maxpdmout = 4094    'maximum bit count for the Phase AtoD converter.  Determined during VNA calibration. Default is 4095
    invdeg = 180        'actual phase change when PDM is inverted.  Default is 180.  Enter actual value after calibration.
    maxpower = 0'-10'0        'maximum power level input to the Log Det, in dBm
        'the maximum input must be below Log Det compression. Nominally 0(0dBm) for LM3356, to as much as 10(+10 dBm)for AD8306/7
    maxbits = 1013'800'       'bit value when maxpower is applied to Log Det
    minus10bits = 956  'bit value when 10 dB less than maxpower is applied to the Log Det
    minus20bits = 845   'bit value when 20 dB less than maxpower is applied to the Log Det
    minus30bits = 732  'bit value when 30 dB less than maxpower is applied to the Log Det
    minus40bits = 616   'bit value when 40 dB less than maxpower is applied to the Log Det
    minus50bits = 490   'bit value when 50 dB less than maxpower is applied to the Log Det
    minus60bits = 372   'bit value when 60 dB less than maxpower is applied to the Log Det
    minus70bits = 250   'bit value when 70 dB less than maxpower is applied to the Log Det
    minus80bits = 170   'bit value when 80 dB less than maxpower is applied to the Log Det
    minus90bits = 150    'bit value when 90 dB less than maxpower is applied to the Log Det
    minus100bits =0  'bit value when 100 dB less than maxpower is applied to the Log Det
    minus110bits =0   'bit value when 110 dB less than maxpower is applied to the Log Det
    minus120bits =0  'bit value when 120 dB less than maxpower is applied to the Log Det
    minus130bits =0  'bit value when 130 dB less than maxpower is applied to the Log Det
    'The following are nominal values you can start with, before calibration
    'nominal value: 8 Bit             12 Bit        16 Bit                  10Bit
    'maxbits =         255               4095            65535              1023
    'minus10bits =  241               3741            59850              935
    'minus20bits =  213               3384            54140                845
    'minus30bits =  186               3024            48380                755
    'minus40bits =  158               2673            42770                668
    'minus50bits =  126               2323            37170                580
    'minus60bits =    97               1981            31700                495
    'minus70bits =    65               1631            26100                407
    'minus80bits =    39               1299            20780                325
    'minus90bits =    28                 971            15540                243
    'minus100bits =  23                 697            11150                174
    'minus110bits =  23                 577              9230                144
    'minus120bits =  23                 556              8900                139
    'minus130bits =  23                 553              8850                138
'--------Normally, nothing below this line will ever need changing----------
    x = 720             'graph horizontal is 720 pixels in width(x), for 800x600 pixel monitor
    y = 300             'graph vertical is 300 pixels in amplitude(y)
    windowwide = 800    'Working and Graph Windows are 800 pixels wide
    maxscale = 255      'height of Log Scale, in pixels, must be less than y
    windowhigh = 185    'Working Window is 180 pixels in height
    graphhigh = 415     'Graph Window is 415 pixels in height
    finalfreq = finalfreq1  'default freq for the last filter center freq using finalfreq1
    finalbw = finalbw1      'default bw for the last filter center freq using finalbw1
    gain = sagain1          'default gain for SA using sagain1
    'the following lines of code are operations and will not be changed by the user unless
        'a different type of Control Board is used.
 
    
    dim datatable(800,3)   'data from most current sweep, 0thisstep(#),1thisfreq(MHz),2thispointpower(dBm),3phaseofpdm(deg)
    dim magarray(800,2)    'magni pixels for each step#: 0pointx, 1oldmagpixel,2newmagpixel
    dim phaarray(800,2)    'phase pixels for each step#: 0notused,1oldphapixel,2newphapixel
    dim calarray(800,2)    'calibration data for each step#: 0notused,1absolutemagnitude(dBm),2absolutephase(deg)


'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'[InitializeDDS1]'reset DDS.  It can power up in a bogus condition.
    gosub [initAD9850] ' reset AD9850 with PIC based control Board ------------> (DDS1 AND DDS3 are re-set by the same command at the same time)
'    gosub [ResetParallelDDS]'needs:control,wclkfqud,contclear ; resets DDS on J5, parallel
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'[InitializeTrkGen]'set PLL3 to proper Rcount, initialize and command Rcounter
if Dbug=1 then print "====================================================================commanding PLL3"
   if PLL3top = 0 then gosub [CreateRcounterPLL3old]'needs:masterclock,PLL3phasefreq ; creates:rcounter3,pdf3
   
'   if PLL3top = 1 then gosub [CreateRcounterPLL3new]'needs:appxDDS3,dds3filbw,PLL3phasefreq ; creates:rcounter3		for 'NEW tracking generator

   gosub [CommandPLL3R]'needs:rcounter3,PLL3mode,PLL3phasepolarity,enat,PLL3 ; Initializes and commands PLL3 Rcounter

[CommandFreqToTrkGen]'set PLL3 to proper Ncount, and change frequency of PLL3
    LO3 = PLL3off
if Dbug=1 then print "calling from [CommandFreqToTrkGen]------>LO3 frequency===> ";LO3
'input xx$
'if PLL topology=0 then the 1013Mhz LO3 (fixed frequency) tracking generator is used
'needs:LO3,rcounter3,masterclock,enat ; commands PLL3 Ncounters ; creates:ncounter3,fcounter3,Bcounter3,Acounter3,LO3
 	'if PLL3top = 0 then  print " gosub [ChangeFreqofPLL3old]":
   	if PLL3top = 0 then gosub [ChangeFreqofPLL3old]

'if PLL topology=1 then the frequency agile LO3 is used																											
'needs:LO3,rcounter3,appxDDS3,enat ; commands PLL3 Ncounters ; creates:ncounter3,fcounter3(0),Bcounter3,Acounter3,dds3output,pdf3
if PLL3top = 1 then gosub [ChangeFreqofPLL3new]'for 'NEW tracking generator
'input xx$

'---------------------------------------------
'[InitializePLL2]'set PLL2 to proper Rcount, initialize and command to LO2 frequency
if Dbug=1 then print "====================================================================commanding PLL2"
    rcounter2 = int(masterclock/PLL2phasefreq)
    if (masterclock/PLL2phasefreq) - rcounter2 >= .5 then rcounter2 = rcounter2 + 1   'rounds off rcounter2
    gosub [CommandPLL2R]'needs:rcounter2,PLL2phasepolarity,enap,PLL2
    pdf2 = masterclock/rcounter2    'actual phase detector frequency of PLL 2
    appxVCO = appxLO2 : reference = masterclock
    gosub [CreateIntegerNcounter]'needs:appxVCO,reference,rcounter ; creates:ncounter,fcounter(0)
    ncounter2 = ncounter:fcounter2 = fcounter
    gosub [CommandPLL2N]'needs:ncounter,fcounter,enap,PLL2
    Bcounter2=Bcounter: Acounter2=Acounter
if Dbug=1 then print "PLL2 now commanded to ";LO2;"  =========PDF2 = ";pdf2;"  ==============================================================="
if Dbug=1 then print:print

'-------------------------------------------
'[InitializePLL1]'set PLL1 to proper Rcount and initialize
    'need appxDDS,PLL1phasefreq,ddsfilbw
if Dbug=1 then print "============================================================= write IBuffer and RBuffer to PLL1"
    rcounter1 = int((appxDDS + (.5*ddsfilbw))/PLL1phasefreq)  'This determines the whole number Reference divide ratio for PLL 1
    if ((appxDDS + (.5*ddsfilbw))/PLL1phasefreq) - rcounter1 >= .5 then rcounter1 = rcounter1 +1
    gosub [CommandPLL1R]'needs:rcounter1,PLL1mode,PLL1phasepolarity,enap,PLL1
if Dbug=1 then print"========================PLL1 initialized===================================================="    
'--------------------------------------------    
'[SetUpWorkingWindow] Create the Working Window, using global variables
    gosub [createWorkingWindow] 'create Working Window for MSA using global default values
'---------------------------------------------
[GrabWorkingWindowData] 'get info from Working window to create Graph Window
'input "about to  --->  gosub [calcWindowInfo] ";xx$
    gosub [calcWindowInfo]
'-------------------------------------------
'[SetUpGraphWindow]  'create the Graph Window, using Working Window data
 if Dbug=1 then if vna = 0 then print "gosub [CreateGraph] "
    if vna = 0 then gosub [CreateGraph] 'create SA Graph and then return here
 if Dbug=1 then if vna = 1 then print "[gosub CreateGraphforVNA] "
    if vna = 1 then gosub [CreateGraphforVNA] 'create VNA Graph and then return here
    if harmonicwindow = 1 then print #harmonicwindow.image0button, "!setfocus"
    print #main.hitkeybox, "!setfocus"  'make sure the "Hit any Key" box has the focus
'----------------------------------------
[SweepFromStartFreq]
if Dbug = 1 then print:input "entered [SweepFromStartFreq] --------------------------->  ";xx$
    print #handle, "discard"    'clear out pc memory of drawn segments
    thisstep = 0                'create step number for beginning of sweep
    lastpointx = 0              'create graph points for beginning of sweep
    lastpointy = y-1
if invdeg = 1 then print " gosub [CalPDMinvdeg] ":gosub [CalPDMinvdeg] 
if Dbug=1 then print:print
if Dbug=1 then print" setup complete -----------  Now entering main loop  ---------------> ";:input xx$
if Dbug=1 then print: print
'---------------------------------------------------------------------------------------------------------------------------------------------------

'============================================================================================================
'============================================================================================================
'============================================================================================================
'============================================================================================================
[CalculateNextStep]'needs:startfreq,stepfreq,thisstep,thisfreq,LO2,finalfreq ; creates:thisfreq,LO1
    thisfreq = startfreq + (stepfreq * thisstep) 'calculates input freq. at this new step
    LO1 = thisfreq + LO2 - finalfreq    'calculates the actual LO1 frequency
if Dbug=1 then print:print:print "Starting new step using frequency ";LO1;" Mhz ==== Step number ";thisstep
if Dbug=1 then input " WWWWWWWWWWWWWWWWWWWWWWWWWW --------------> ";xx$



'[CalculateNforPLL1]'needed:LO1,appxDDS,rcounter1,spurcheck ; creates:ncounter1,fcounter1,pdf1,ddsoutput
gosub [CreatePLL1asInteger]'needs:LO1,appxDDS,rcounter1 ; creates:ncounter1,fcounter1(0),pdf1,ddsoutput

'[CommandDDSforPLL1]needed:ddsoutput,masterclock,lastddsoutput,appxDDS,ddsfilbw
    if ddsoutput = lastddsoutput then goto [endCommandDDSforPLL1]  'skip if DDS frequency does not need changing
    if ddsoutput-appxDDS>ddsfilbw/2 then beep:error$="DDSoutput too high for filter"
    if appxDDS-ddsoutput>ddsfilbw/2 then beep:error$="DDSoutput too low for filter"
    if ddsoutput < lastddsoutput then glitch = 1    'add delay to prevent PLL settling glitch
    ddsclock = masterclock
    gosub [CreateBaseForDDS]'needs:ddsoutput,ddsclock ; creates: base
    
    gosub [DDS1command]'needs:base,word0,port,control,wclk,fqud,contclear ; 				command DDS to change frequency of DDS1
    lastddsoutput = ddsoutput
[endCommandDDSforPLL1]

'-----------------------------------------
'[CommandPLL1]'needed:ncounter1,fcounter1,PLL1mode,enap,PLL1
if Dbug=1 then print "goingsub [CommandPLL1N] "
    gosub [CommandPLL1N]'needs:ncounter1,fcounter1,PLL1mode,enap,PLL1 ; commands PLL NBuffer
if Dbug=1 then print " returned from sub [CommandPLL1N] "

'--------------------------------------------
'[UpdateNewTrkGen]This is skipped if TG is original topology or turned "OFF"
if Dbug=1 and PLL3top=1 then print:print"New PPL3 topology and track generator invoked ???????????????"
if PLL3top = 1 and trkgen = 1 then print"YES -----  NOW [UpdateNewTrkGen]This is skipped if TG is original topology or turned OFF"
if PLL3top = 1 and trkgen = 1 then LO3=LO2 + thisfreq + PLL3offset:gosub [ChangeFreqofPLL3new]:glitch = 1
'when new TG changes freq, it takes time to settle, during which, the Phase Det Module is invalid, therefore, add glitch time
'---------------------------------------------
'[ResetPhaseDetModule]Set the PDM phase for last known mode, since it is likely a PLL3 command will reset the PDM to Norm. Put it here, before [SettleDownTime].
'if Dbug=1 then print
'if Dbug=1 then print"Either SET OR RESET 'D' on U4b, ---   THEN read PHADATA"
'if Dbug=1 then if vna = 1 then print  "out port,pdm*128= "; pdm*128;" and pulse ENAP HI and return to LO"
'    if vna = 1 then out port, pdm*128: out control, enap: out control, contclear: out port, 0  'pdm is determined in [InvertPDmodule]
'if Dbug=1 then print
'----------------------
'[SettleDownTime]'needed:wate,glitch,glitchtime ; this slows the program
    for waittime=0 to (wate * 100)+(glitch*glitchtime)  'allows time for ckts to settle before data sampling
    next waittime
    glitch = 0  'reset glitch variable back to 0
'----------------------
'[ReadMagnitude]'needed: port,status ; creates: magdata (and phadata for PIC ADC and for 16 bit)
if Dbug=1 then print "goingsub [logData10Bit_PIC] ---- reading magdata "'Read PIC ADC and return here with magdata and phadata 
	gosub [logData10Bit_PIC]
'----------------------
'[ReadPhase]'Read the voltage from the Phase Detector Module with the proper AtoD
    if vna = 0 then goto [ConvertAtoDbits]   'skip computing  phase data
'----------------------    

if Dbug=1 and (phadata/maxpdmout < .2 or phadata/maxpdmout > .8) then input " gosub [InvertPDmodule ----  data is near dead zone, invert the PDM phase to keep data linear]"; xx$
	if phadata/maxpdmout < .2 or phadata/maxpdmout > .8 then gosub [InvertPDmodule]   'data is near dead zone, invert the PDM phase to keep data linear
    phaseofpdm = val(using("####.##",(360*phadata/maxpdmout)))  'converts phadata bits to phase and round off to .01 degrees
    if pdm = 1 then phaseofpdm = phaseofpdm + invdeg   'invdeg is the actual inverted phase change
    if phaseofpdm > 360 then phaseofpdm = phaseofpdm - 360
    if phaseofpdm > 180 then phaseofpdm = phaseofpdm - 360  'the phaseofpdm will be from -180 to +180
    if calfwd = 1 then calarray(thisstep,2)= phaseofpdm    'this inserts the absolute phase into the calarray for phase reference
    phaseofpdm = phaseofpdm - calarray(thisstep,2)  'this gives the differential phase from calibration
    if phaseofpdm > 180 then phaseofpdm = phaseofpdm - 360
    if phaseofpdm < -180 then phaseofpdm = phaseofpdm + 360
    datatable(thisstep,3) = phaseofpdm    'put current phase measurement into the array, line value= thisstep
    'convert phase to pixels
    thispointphase = maxscale * (phaseofpdm - botphase)/(topphase - botphase)
    if phaseofpdm >= topphase then thispointphase = maxscale
    if phaseofpdm <= botphase then thispointphase = 0

[ConvertAtoDbits]
    gosub [ConvertMagdataToPower]'needs: calibration table ; creates thispointpower
    if calfwd = 1 then calarray(thisstep,1)= thispointpower    'this inserts the power into the calarray for magnitude reference
    if vna = 1 then thispointpower = thispointpower - calarray(thisstep,1)  'this gives the differential power from calibration
    gosub [ConvertPowerToPixels]'needs:thispointpower,topref,botref ; creates thispointmag
    datatable(thisstep,0) = thisstep    'put current step number into the array, line value= thisstep
    datatable(thisstep,1) = thisfreq    'put current frequency into the array, line value= thisstep
    datatable(thisstep,2) = thispointpower    'put current power measurement into the array, line value= thisstep

'[PlotDataOnGraph]
    if vna = 0 then gosub [PlotDataSA]'needs:thisstep,x,steps,rewrite,thispointx,y,thispointmag,lastpointx,lastpointy ; creates:lastpointx,lastpointy and plots magdata
    if vna = 1 then gosub [PlotDataVNA]'needed:thisstep,x,steps,rewrite,y,thispointmag,thispointphase ; plots magdata,phadata

'[DetermineNextOperation]
    if varwindow = 1 then gosub [updatevar]
    print #main.hitkeybox, "!contents? stop$"  'look at "Hit any key" box, stop sweep if anything there
    if len(stop$)>0 then gosub [Halted]

[IncrementOneStep]
    thisstep = thisstep + 1 'add 1 to step and continue sweeping
if Dbug=1 then print "at [IncrementOneStep]   ---- thisstep = ";thisstep
    if calfwd = 1 and thisstep > steps then calfwd = 0:beep:print #main.calibfwd, "Calibrated":print #main.hitkeybox, "end":wait
    if thisstep > steps then goto [SweepFromStartFreq] 'end of sweep, start over
    goto [CalculateNextStep]
'============================================================================================================
'============================================================================================================
'============================================================================================================
'============================================================================================================

'----SubRoutines------

[InvertPDmodule]'Change Phase Det Module 180 degrees and take data again. 
'input "entered [InvertPDmodule] ";xx$
    if pdm = 0 then inv = 1
    if pdm = 1 then inv = 0
'    out port, inv*128'					128=1000 0000 i.e BD7 - so set BD7 if PDM=0  or  clear BD7 if PDM=1
'    out control, enap'					toggle ENAP when ENAP transits from LO to HI then the value of BD7 is clocked to Q on U4b
'    out control, contclear
'    out port, 0    'commands the phase det module to invert					IS THIS the NORMAL state?????????????
      'The PDM needs time to settle after a phase change, play with following:
      
    
    for waittime = 0 to (wate * 100)   'The delay required, depends on the RC time constant of the Phase Det Module output
    next waittime       '1 for "wate" seems good for .01 ufd as C1
    
    
'    if adconv = 8 then gosub [logData8Bitpha] 'and return here with phadata
    
    ' input "  gosub [logData10Bit_PIC] ";xx$
   gosub [logData10Bit_PIC] 'and return here with phadata, and new magdata 
   ' input " returning from[logData10Bit_PIC] ";xx$

    if inv = 0 then pdm = 0
    if inv = 1 then pdm = 1
' input "leaving [InvertPDmodule] ";xx$   
    return  'with new phadata, and new magdata if using 16 bit

'----------------------------------------------------------------------------------------------------------------------------------------------

[CalPDMinvdeg]
    beep
    pdm = 0
'    out port, pdm*128: out control, enap: out control, contclear: out port, 0
    for waittime = 0 to 600000
    next waittime

    gosub [logData10Bit_PIC] 'and return here with phadata, and new magdata    

    phadata0 = phadata
    pdm = 1
 '  out port, pdm*128: out control, enap: out control, contclear: out port, 0
    for waittime = 0 to 600000
    next waittime
 
    gosub [logData10Bit_PIC] 'and return here with phadata, and new magdata
 
 
    invdeg = val(using("####.##",(360*(phadata0-phadata)/maxpdmout)))
    print #main.invdegbox,invdeg
    beep
    print #main.hitkeybox, "Cald"
    wait


'==========================================================================================================================
[logData10Bit_PIC]'needed port,status;magdata,phadata -----------------     'SERIAL INTERFACE
'goto [ECP9X]

if Dbug=1 then input "entering [logData10Bit_PIC] ----------> ";xx$

parm$(0)=chr$(4)' Measure and read MAG and PHA
parm$(1)=chr$(0)' Not used 
parmDONE$=chr$(255)

'if PICRUN=1 then print "parms to read ADC"
	for Parm =0 to 1
		'if PICRUN=1 then print asc(parm$(Parm))
		if PICRUN=1 then print #2,parm$(Parm);								'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
	next Parm
	        
if Dbug=1 then print asc(parmDONE$)
if PICRUN=1 then print #2,parmDONE$;										'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
    
'MAG and PHA is read from serial port in 8 bits. First lower byte, then upper byte --- both right justfied 
    magdata = 0
    phadata = 0
    

[ECP9]

if PICRUN=0 then goto [picrun8]
	if lof(#2) < 5 then goto [ECP9]		'RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR

	checkbyte1$=	input$(#2,1)   											'RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
	magLO$=			input$(#2,1):	magLO=	asc( magLO$)					'RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
	magHI$=			input$(#2,1):	magHI=	asc(magHI$)						'RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
	phaLO$=			input$(#2,1):	phaLO=	asc(phaLO$)						'RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
	phaHI$=			input$(#2,1):	phaHI=	asc(phaHI$)						'RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
	checkbyte2$=	input$(#2,1)											'RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
[picrun8]


if Dbug=1 then print
if Dbug=1 then print "Mag and Pha data returned from PIC"
if Dbug=1 then print "checkbyte1=";	asc(checkbyte1$)
if Dbug=1 then print "magLO=";		asc(magLO$)
if Dbug=1 then print "magHI=";		asc(magHI$)
if Dbug=1 then print "phaLO=";		asc(phaLO$)
if Dbug=1 then print "phaHI=";		asc(phaHI$)
if Dbug=1 then print "checkbyte2=";	asc(checkbyte2$)
	magdata=		magHI*256	+magLO
	phadata=		phaHI*256	+phaLO

if Dbug=1 then 	print "magdata = ";magdata
if Dbug=1 then 	print "phadata = ";phadata

if Dbug=3 then 	print "magdata = ";magdata;
if Dbug=3 then 	print "   phadata = ";phadata


[ECP9X]
return '[logData10Bit_PIC]
'==========================================================================================================================



'

[ConvertMagdataToPower]'needed: calibration table ; creates thispointpower
    'convert magnitude data bits to power, using cal table (in dBm at input to Log Detector)
    if magdata < minus130bits then power = maxpower-130
    if magdata >= minus130bits and magdata <minus120bits then power = maxpower-120 - 10*(minus120bits-magdata)/(minus120bits-minus130bits)
    if magdata >= minus120bits and magdata <minus110bits then power = maxpower-110 - 10*(minus110bits-magdata)/(minus110bits-minus120bits)
    if magdata >= minus110bits and magdata <minus100bits then power = maxpower-100 - 10*(minus100bits-magdata)/(minus100bits-minus110bits)
    if magdata >= minus100bits and magdata <minus90bits  then power = maxpower-90 - 10*(minus90bits-magdata)/(minus90bits-minus100bits)
    if magdata >= minus90bits  and magdata <minus80bits  then power = maxpower-80 - 10*(minus80bits-magdata)/(minus80bits-minus90bits)
    if magdata >= minus80bits  and magdata <minus70bits  then power = maxpower-70 - 10*(minus70bits-magdata)/(minus70bits-minus80bits)
    if magdata >= minus70bits  and magdata <minus60bits  then power = maxpower-60 - 10*(minus60bits-magdata)/(minus60bits-minus70bits)
    if magdata >= minus60bits  and magdata <minus50bits  then power = maxpower-50 - 10*(minus50bits-magdata)/(minus50bits-minus60bits)
    if magdata >= minus50bits  and magdata <minus40bits  then power = maxpower-40 - 10*(minus40bits-magdata)/(minus40bits-minus50bits)
    if magdata >= minus40bits  and magdata <minus30bits  then power = maxpower-30 - 10*(minus30bits-magdata)/(minus30bits-minus40bits)
    if magdata >= minus30bits  and magdata <minus20bits  then power = maxpower-20 - 10*(minus20bits-magdata)/(minus20bits-minus30bits)
    if magdata >= minus20bits  and magdata <minus10bits  then power = maxpower-10 - 10*(minus10bits-magdata)/(minus10bits-minus20bits)
    if magdata >= minus10bits  and magdata <maxbits      then power = maxpower - 10*(maxbits-magdata)/(maxbits-minus10bits)
    if magdata >= maxbits then power = maxpower
    'if adconv = 8 then thispointpower = val(using("####.#",power))-gain  'round off power to .1 dB
    if adconv = 10 then thispointpower = val(using("####.##",power))-gain  'round off power to .01 dB
    'if adconv = 12 then thispointpower = val(using("####.##",power))-gain  'round off power to .01 dB
    'if adconv = 16 then thispointpower = val(using("####.##",power))-gain  'round off power to .01 dB
    return

[ConvertPowerToPixels]'needed:thispointpower,topref,botref ; creates thispointmag
    if thispointpower > topref then thispointmag = maxscale
    if thispointpower <= topref and thispointpower >= botref then thispointmag = maxscale*(thispointpower-botref)/(topref-botref)
    if thispointpower < botref then thispointmag = 0
    return

[PlotDataSA]'needed:thisstep,x,steps,rewrite,y,thispointmag,lastpointx,lastpointy ; creates:lastpointx,lastpointy and plots magdata
    thispointx = thisstep * x / steps  'establishes data point on the x-axis of graph (0 to 720)
    print #handle, "color white"  'quick way to clear trace
    fy=3
    for xx=1 to 25
    print #handle, "line ";thispointx+xx;" ";fy;" ";thispointx+xx;" ";fy-10'275 indicator for sweep progress on top of graph
    next xx
    
    if rewrite = 0 then print #handle, "line ";thispointx;" ";y;" ";thispointx;" ";y-275
        'display a white line,hiding previous data points, during normal sweep
    print #handle, "color black"
    
    print #handle, "line ";thispointx;" ";fy;" ";thispointx;" ";fy-10'275
    
    
    if rewrite = 0 then print #handle, "line ";thispointx;" ";y;" ";thispointx;" ";(y-1)-thispointmag
        'display a data line during normal sweep
    if rewrite = 1 then print #handle, "line ";thispointx;" ";(y-1)-thispointmag;" ";lastpointx;" ";lastpointy
        'connect the data dots during rewrite mode, one pixel higher than normal sweep
    if thisstep = marker1 then gosub [insertMarker]'and return here after inserting marker
    if thisstep = marker2 then gosub [insertMarker]'and return here after inserting marker
    if thisstep = marker3 then gosub [insertMarker]'and return here after inserting marker/
    lastpointx = thispointx     'remember previous data point for next data take
    lastpointy = (y-1)-thispointmag
    return

[insertMarker]  'display marker info (vertical line and data info)
    print #handle, "line ";thispointx;" ";(y-15)-thispointmag;" ";thispointx;" ";(y-2)-thispointmag
    print #handle, "line ";thispointx;" ";y+6;" ";thispointx;" ";y+10
    if vna = 0 then print #handle, "\\"; thisfreq;" MHz\";magdata; " = bits\";thispointpower;" dBm"
    if vna = 1 then print #handle, "\\"; thisfreq;" MHz\";thispointpower;" dB\";phaseofpdm; " deg"
    return  'return to [PlotData]

[PlotDataVNA]'needed:thisstep,x,steps,rewrite,y,thispointmag,thispointphase ; plots magdata,phadata
    previousstep = thisstep - 1
    if previousstep < 0 then previousstep = 0   'this should keep the first step clean (step 0)
    thispointx = thisstep * x/steps  'establishes pixel point on the x-axis of graph (0 to 720)
    'plot Magnitude
    newmagpixel = y-thispointmag
    print #handle, "color white"
    if rewrite = 0 then print #handle, "line ";magarray(previousstep,0);" ";magarray(previousstep,1);" ";thispointx;" ";magarray(thisstep,2)
    'display a white line,from laststep old point to thisstep old point, covering up old line
    print #handle, "color blue"
    print #handle, "line ";magarray(previousstep,0);" ";magarray(previousstep,2);" ";thispointx;" ";newmagpixel
    magarray(thisstep,0) = thispointx               'this is the x-axis pixel value for this step, used in the next step as the previous step's x position
    magarray(thisstep,1) = magarray(thisstep,2) 'this is the previous sweep's y-axis pixel value at this step #, used in next step for clearing old trace
    magarray(thisstep,2) = newmagpixel          'this is the newest y-axis pixel value for this step, used in next step to extend new trace
    'plot Phase
    print #handle, "color white"
    if rewrite = 0 then print #handle, "line ";magarray(previousstep,0);" ";phaarray(previousstep,1);" ";thispointx;" ";phaarray(thisstep,2)
    'display a white line,from laststep old point to thisstep old point, covering up old line
    print #handle, "color red"
    newphapixel = y-thispointphase
    print #handle, "line ";magarray(previousstep,0);" ";phaarray(previousstep,2);" ";thispointx;" ";newphapixel
    phaarray(thisstep,1) = phaarray(thisstep,2) 'this is the previous sweep's y-axis pixel value at this step #, used in next step for clearing old trace
    phaarray(thisstep,2) = newphapixel          'this is the newest y-axis pixel value for this step, used in next step to extend new trace
    print #handle, "color black"
    if thisstep = marker1 then gosub [insertMarker]'and return here after inserting marker
    if thisstep = marker2 then gosub [insertMarker]'and return here after inserting marker
    if thisstep = marker3 then gosub [insertMarker]'and return here after inserting marker
    return

[CommandPLL1R]'needed:rcounter1,PLL1mode,PLL1phasepolarity,enap,PLL1
    rcounter = rcounter1
    preselector = 32 : if PLL1mode = 1 then preselector = 16
    phasepolarity = PLL1phasepolarity    'inverting op amp is 0, non-inverting loop is 1
    fractional = PLL1mode       '0 for Integer-N; 1 for Fractional-N
    Jcontrol = enap   'for PLL 1, on Control Board J1, the value is "3"
    LEPLL = 4         'for PLL 1, on Control Board J1, the value is "4"
    PLL = PLL1
CR=1    
if Dbug=1 then print "calling from [CommandPLL1R] and going to  [CommandRBuffer]' "
    gosub [CommandRBuffer]'needs:rcounter,preselector,phasepolarity,fractional,Jcontrol,LEPLL,PLL
    if len(errora$)>0 then error$ = "PLL 1, " + errora$:errora$ = ""
    return'[CommandPLL1R]'

[CommandPLL2R]'needed:rcounter2,PLL2phasepolarity,enap,PLL2
    rcounter = rcounter2
    preselector = 32
    phasepolarity = PLL2phasepolarity    'inverting op amp is 0, non-inverting loop is 1
    fractional = 0    '0 for Integer-N; PLL 2 should not be fractional due to increased noise
    Jcontrol = enap   'for PLL 2, on Control Board J2, the value is "3"
    LEPLL = 8          'for PLL 2, on Control Board J2, the value is "8"
    PLL = PLL2
CR=2  
if Dbug=1 then print "calling from [CommandPLL2R] and going to  [CommandRBuffer]' "   
   gosub [CommandRBuffer]
    if len(errora$)>0 then error$ = "PLL 2, " + errora$:errora$ = ""
    return'[CommandPLL2R]

[CommandPLL3R]'needed:rcounter3,PLL3mode,PLL3phasepolarity,enat,PLL3
    rcounter = rcounter3
    preselector = 32 : if PLL3mode = 1 then preselector = 16
    phasepolarity = PLL3phasepolarity    'inverting op amp is 0, non-inverting loop is 1
    fractional = PLL3mode       '0 for Integer-N; 1 for Fractional-N
    Jcontrol = enat   'for Tracking Gen PLL, on Control Board J3, the value is "15"
    LEPLL = 16         'for Tracking Gen PLL, on Control Board J3, the value is "16"
    PLL = PLL3
CR=3
 gosub [CommandRBuffer]'needs:rcounter,preselector,phasepolarity,fractional,Jcontrol,LEPLL,PLL
return'[CommandPLL3R]

[CommandRBuffer]'needed:rcounter,preselector,phasepolarity,fractional,Jcontrol,LEPLL,PLL
'print "calling from [CommandRBuffer]"
       if PLL = 2326 then gosub [Command2326R]'needs:rcounter,phasepolarity,Jcontrol,port,LEPLL,contclear ; commands LMX2326 rcounter and registers
  return'[CommandRBuffer]

[CreatePLL1asInteger]'needed:LO1,appxDDS,rcounter1 ; creates:ncounter1,fcounter1(0),pdf1,ddsoutput
    ncount1 = LO1/(appxDDS/rcounter1)  'approximates the Ncount for PLL 1
    ncounter1 = int(ncount1)    'actual value for PLL1 Ncounter
    if ncount1 - ncounter1 >= .5 then ncounter1 = ncounter1 + 1
    fcounter1 = 0
    pdf1 = LO1/ncounter1        'actual phase freq of PLL1
    ddsoutput = pdf1 * rcounter1    'actual output of DDS(input Ref to PLL1)
    return

[CommandPLL1N]'needed:ncounter1,fcounter1,PLL1mode,enap,PLL1 ; commands PLL NBuffer
if Dbug=1 then if (ncounter1 = lastncounter1) and (fcounter1 = lastfcounter1) then print "no update needed "
    if (ncounter1 = lastncounter1) and (fcounter1 = lastfcounter1) then return 'cmd not needed
    glitch=1                'add delay to prevent PLL settling glitch
    ncounter = ncounter1
    fcounter = fcounter1
    preselector = 32 : if PLL1mode = 1 then preselector = 16
'    Jcontrol = enap   '0000 0011 =3   Jcontrol writes to CONTROL PORT, ENAP=Hi, ENAT=Lo, WCLK=Lo, FQUD=Lo -- for PLL 1, on Control Board J1, the value is "3"
    LEPLL = 4           '0000 0100 = 4   LEPLL writes to DATA PORT  for PLL 1, on Control Board J1, the value is "4"
    PLL = PLL1
if Dbug=1 then print "in  [CommandPLL1N] and calling  CommandNBuffer]"
CN=1
    gosub [CommandNBuffer]'needs:ncounter,fcounter,preselector,Jcontrol,LEPLL,PLL
    if len(errora$)>0 then error$ = "PLL 1, " + errora$:errora$ = ""
    Bcounter1=Bcounter: Acounter1=Acounter
    lastncounter1 = ncounter1 'established comparison in above code
    lastfcounter1 = fcounter1 'established comparison in above code
    return

[CommandPLL2N]'needed:ncounter,fcounter,enap,PLL2
    preselector = 32
    Jcontrol = enap   'for PLL 2, on Control Board J2, the value is "3"
    LEPLL = 8          'for PLL 2, on Control Board J2, the value is "8"
    PLL = PLL2
if Dbug=1 then print "in [CommandPLL2N] and calling  CommandNBuffer]"
CN=2
    gosub [CommandNBuffer]'needs:ncounter,fcounter,preselector,Jcontrol,LEPLL,PLL
    if len(errora$)>0 then error$ = "PLL 2, " + errora$:errora$ = ""
    LO2=((Bcounter*preselector)+Acounter+(fcounter/16))*pdf2
    return


[CommandPLL3N]'needed:ncounter,fcounter,PLL3mode,enat,PLL3
    preselector = 32 : if PLL3mode = 1 then preselector = 16
    Jcontrol = enat   'for Tracking Gen PLL, on Control Board J3, the value is "15"
    LEPLL = 16         'for Tracking Gen PLL, on Control Board J3, the value is "16"
    PLL = PLL3
if Dbug=1 then print "Calling   [CommandNBuffer] from  [CommandPLL3N]   and LO3 = "; LO3
CN=3
    gosub [CommandNBuffer]'needs:ncounter,fcounter,preselector,Jcontrol,LEPLL,PLL
    if len(errora$)>0 then error$ = "PLL 3, " + errora$:errora$ = ""
if Dbug=1 then print "PLL3    now commanded to =========================> ";LO3;" Mhz"
if Dbug=1 then print
if Dbug=1 then print
    return

[CommandNBuffer]'needed:ncounter,fcounter,preselector,Jcontrol,LEPLL,PLL
	gosub [Command2326N]'needs:ncounter,Jcontrol,port,LEPLL,contclear ; commands LMX2326 ncounter ; creates Bcounter,Acounter
    return 'with Bcounter,Acounter

[CreateIntegerNcounter]'needed:appxVCO,reference,rcounter ; creates:ncounter,fcounter(0)
    ncounter = int(appxVCO/(reference/rcounter))     'approximates the ncounter for PLL
    if (appxVCO/(reference/rcounter)) - ncounter >= .5 then ncounter = ncounter + 1   'rounds off ncounter
    fcounter = 0
    return



'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'pack bits into bytes and send to PIC to preserve programming flexibility
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  
[Command2326R]'needed:rcounter,phasepolarity,Jcontrol,port,LEPLL,contclear ; commands LMX2326 rcounter and registers
    '[Create2326InitBuffer]'need phasepolarity
if Dbug=1 then input "entering [Command2326R]  writing I Buffer ====> ";xx$
if Dbug=1 then print
if Dbug=1 then print "in [Command2326R] i.e. creating and writing to Ibuffer and Rbuffer to PLL";CR
    I21=0     'Test, use 0
    I20=0     '1=Power Down Mode, use 0
    I19=0     'Test, use 0
    I18=0     'Test, use 0
    I17=0     'Test, use 0
    I16=0     'Fastlock Time out value, use 0
    I15=0     'Fastlock Time out value, use 0
    I14=0     'Fastlock Time out value, use 0
    I13=0     'Fastlock Time out value, use 0
    I12=0     '1=Time out enable, use 0
    I11=0     'Fastlock control, use 0
    I10=0     '1=Fastlock enable, use 0
    I9=0     	'1=Tristate the phase det output, use 0 TriState	R divider out
    I8 = phasepolarity     'Phase det polarity, 1=pos  0=neg
    I7=0		'FoLD control(pin14 output), 0= tristate, 1= R Divider out	F5	0 1	see p10 for the other combinations
   			
    I6=0        '2= N Divider out, 3= Serial Data Output, 4= Digital Lock Detect F4	0	0

    I5=0        '5= Open drain lock detect, 6= High output, 7= Low output F3	0 0
    I4=0        '1= Power Down, use 0
    I3=0        '1= Counter Reset Enable, allows reset of R,N counters,use 0
    I2=1        'F1 address bit 1, must be 1
    I1=1        'F1 address bit 0, must be 1
    
if Dbug=1 then print "parms for  I buffer in  [Command2326R] PLL";CR;" LEPLL = ";LEPLL
    parm$(0)=chr$(2)'  Command PLL SPI bus 
    ' Construct byte data for I buffer to be sent to PIC
    parm$(1)=chr$(I21*2^7+I20*2^6+I19*2^5+I18*2^4+I17*2^3+I16*2^2+I15*2^1+I14*2^0)
	parm$(2)=chr$(I13*2^7+I12*2^6+I11*2^5+I10*2^4+I9*2^3+I8*2^2+I7*2^1+I6*2^0)
    parm$(3)=chr$(I5*2^7+I4*2^6+I3*2^5+I2*2^4+I1*2^3)
    
    if LEPLL=4   	then   parm$(4)=chr$(1)' Command PLL1
    if LEPLL=8   	then   parm$(4)=chr$(2)' Command PLL2
    if LEPLL=16 	then   parm$(4)=chr$(3)' Command PLL3
    
    parm$(5)=chr$(200)' Delay between data pulses
    parm$(6)=chr$(10)' Not used 
    parm$(7)=chr$(10)' Not used 
    parm$(8)=chr$(10)' Not used 
    
    parmDONE$=chr$(255)
	        for Parm=0 to 8
if Dbug=1 then print asc(parm$(Parm))'PPPPPPPPPPPPPPPPPPPPPPPPPP[Command2326Rbuffer] 'I' PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
if PICRUN=1 then print #2,parm$(Parm);											'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
	        	call Pause SERIALdelay 'Adjustable delay (in uS) between sending bytes to PIC
	        next Parm
if Dbug=1 then print asc(parmDONE$)
if PICRUN=1 then print #2,parmDONE$;											'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP

if Dbug=1 then print "              2 1 111 1111 110 0 0 000 0 0 00  L"
if Dbug=1 then print "              0 9 876 5432 109 8 7 654 3 2 10  E"
if Dbug=1 then print "I    Buffer = ";I21;" ";I20;" ";I19;I18;I17;" ";I16;I15;I14;I13;" ";I12;I11;I10;" ";I9;" ";I8;" ";I7;I6;I5;" ";I4;" ";I3;" ";I2;I1;"  ";LEPLL;" ";0
if Dbug=1 then print
if Dbug=1 then print 
if Dbug=1 then print "------ I buffer written for PLL";CR;"------------> 		";
if Dbug=1 then input "I Buffer written ====>";xx$

ercount=0
[ECP5]
	ercount=ercount+1
	if PICRUN=0 then goto [picrun7]
	if Dbug=1 then print "Waiting for ACK at [ECP5] (Ibuffer) ercount= ";ercount
	if lof(#2) < 1 then goto [ECP5]			
 	dataRead$ = input$(#2, lof(#2))
 		if left$(dataRead$ ,1) <> chr$(255) and Dbug=1 then
			print "NO ack at N buffer[ECP5]"
			gosub [printdataRead]
			input"----> ";xx$
 		else
 			if Dbug=1 then print "ack received":print "=========================================="
		end if	
[picrun7]
'----------- I buffer done-----------


if Dbug=1 then input "entering [Command2326R]  writing R Buffer ====> ";xx$   
    '[Create2326Rbuffer]'need rcounter
    if rcounter <3 then beep:errora$="2326 R counter <3"
    if rcounter >16383 then beep:errora$="2326 R counter >16383"
    r1 = 0                   'R address bit 0, must be 0
    r2 = 0                   'R address vit 1, must be 0
    ra0 = int(rcounter/2):r3 = rcounter- 2*ra0    'LSB R0
    ra1 = int(ra0/2):r4 = ra0- 2*ra1
    ra2 = int(ra1/2):r5 = ra1- 2*ra2
    ra3 = int(ra2/2):r6 = ra2- 2*ra3
    ra4 = int(ra3/2):r7 = ra3- 2*ra4
    ra5 = int(ra4/2):r8 = ra4- 2*ra5
    ra6 = int(ra5/2):r9 = ra5- 2*ra6
    ra7 = int(ra6/2):r10 = ra6- 2*ra7
    ra8 = int(ra7/2):r11 = ra7- 2*ra8
    ra9 = int(ra8/2):r12 = ra8- 2*ra9
    ra10 = int(ra9/2):r13 = ra9- 2*ra10
    ra11 = int(ra10/2):r14 = ra10- 2*ra11
    ra12 = int(ra11/2):r15 = ra11- 2*ra12
    ra13 = int(ra12/2):r16 = ra12- 2*ra13  'MSB
    r17 = 0     'Test Bit
    r18 = 0     'Test Bit
    r19 = 0     'Test Bit
    r20 = 0     'Test Bit
    r21 = 0     'Lock Detector Mode, 0=3 refcycles, 1=5 cycles
    
if Dbug=1 then print "parms for R buffer in  [Command2326Rbuffer] PLL";CR;"  LEPLL = ";LEPLL
   		parm$(0)=chr$(2)'  Command PLL SPI bus 
	    
	    parm$(1)=chr$(r21*2^7+r20*2^6+r19*2^5+r18*2^4+r17*2^3+r16*2^2+r15*2^1+r14*2^0)' Construct byte data to be sent to PIC
		parm$(2)=chr$(r13*2^7+r12*2^6+r11*2^5+r10*2^4+r9*2^3+r8*2^2+r7*2^1+r6*2^0)
	    parm$(3)=chr$(r5*2^7+r4*2^6+r3*2^5+r2*2^4+r1*2^3)
	    
	    if LEPLL=4   then   parm$(4)=chr$(1)' Command PLL1
	    if LEPLL=8   then   parm$(4)=chr$(2)' Command PLL2
	    if LEPLL=16 then   parm$(4)=chr$(3)' Command PLL3
	    
	    parm$(5)=chr$(200)' Delay between data pulses
	    parm$(6)=chr$(10)' Not used 
	    parm$(7)=chr$(10)' Not used 
	    parm$(8)=chr$(10)' Not used 
	    
	    parmDONE$=chr$(255)
		        for Parm=0 to 8
if Dbug=1 then print asc(parm$(Parm))'PPPPPPPPPPPPPPPPPPPPP[Command2326Rbuffer 'R' ]PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
if PICRUN=1 then print #2,parm$(Parm);													'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
	        	call Pause SERIALdelay 'Adjustable delay (in uS) between sending bytes to PIC
		        next Parm
if Dbug=1 then print asc(parmDONE$) 
if PICRUN=1 then print #2,parmDONE$;													'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP

if Dbug=1 then print "rcounter = ";rcounter
if Dbug=1 then print "              2   1111   11111100000000    00  L"
if Dbug=1 then print "              0   9876   54321098765432    10  E"
if Dbug=1 then print "R    Buffer = ";r21;"   ";r20;r19;r18;r17;"   ";r16;r15;r14;r13;r12;r11;r10;r9;r8;r7;r6;r5;r4;r3;"    ";r2;r1;"  ";LEPLL;" ";0
if Dbug=1 then print
if Dbug=1 then print
if Dbug=1 then print "------ R buffer written for PLL";CR;"  ------------> ";
if Dbug=1 then input " R buffer written ====> ";xx$

ercount=0


[ECP4]
ercount=ercount+1
if PICRUN=0 then goto [picrun6]
	if Dbug=1 then print "Waiting for ack at [ECP4] (RBuffer)"
	if lof(#2) < 1 then goto [ECP4]
	
 	dataRead$ = input$(#2, lof(#2))	
	if left$(dataRead$ ,1) <> chr$(255) and Dbug=1 then
		print "NO ack at R buffer[ECP4]"
		gosub [printdataRead]
		input"----> ";xx$
	else
	if Dbug=1 then print "ack received":print "=========================================="	
	end if	
[picrun6]
'----------- R buffer done-----------
     return'[Command2326Rbuffer]
     

[Command2326N]'needed:ncounter,Jcontrol,port,LEPLL,contclear ; commands LMX2326 ncounter
    'need ncounter,Jcontrol,LEPLL,contclear
if Dbug=1 then input "entering [Command2326N]  writing N Buffer ====> ";xx$ 
if Dbug=1 then  print "in [Command2326N] and programming PLL";CN 
if Dbug=1 then  print "rcounter1= ";rcounter1;" CN= ";CN
if Dbug=1 then  print "rcounter2= ";rcounter2
if Dbug=1 then  print "rcounter3= ";rcounter3
 if CN=1 then rcounterTMP=rcounter1:DDSfreq=ddsoutput		'Program PLL1
 if CN=2 then rcounterTMP=rcounter2:DDSfreq=64				'Program PLL2
 if CN=3 then rcounterTMP=rcounter3:DDSfreq=dds3output		'Program PLL3
if Dbug=1 then  print "rcounterTMP= ";rcounterTMP
if Dbug=1 then  print "DDSfreq= ";DDSfreq
    Bcounter = int(ncounter/32)
    Acounter = int(ncounter-(Bcounter*32))
    
if Dbug=1 and CN=1 then
	print "writing to N buffer======================== LO1 frequency ="; ((32*Bcounter)+Acounter)*(DDSfreq/rcounterTMP);" MHz"
end if	
    
    if Bcounter < 3 then beep:errora$="2326 B counter <3"
    if Bcounter > 8191 then beep:errora$="2326 B counter >8191"
    if Bcounter < Acounter then beep:errora$="2326 B counter<Acounter"
    N1 = 1       'n address bit 0, must be 1
    N2 = 0       'n address bit 1, must be 0
    na0 = int(Acounter/2):N3 = Acounter- 2*na0      'Acounter bit 0 LSB
    na1 = int(na0/2):N4 = na0 - 2*na1
    na2 = int(na1/2):N5 = na1 - 2*na2
    na3 = int(na2/2):N6 = na2 - 2*na3
    na4 = int(na3/2):N7 = na3 - 2*na4               'Acounter bit 4 MSB
    nb0 = int(Bcounter/2):N8 = Bcounter- 2*nb0      'Bcounter bit 0 LSB
    nb1 = int(nb0/2):N9 = nb0 - 2*nb1
    nb2 = int(nb1/2):N10 = nb1 - 2*nb2
    nb3 = int(nb2/2):N11 = nb2 - 2*nb3
    nb4 = int(nb3/2):N12 = nb3 - 2*nb4
    nb5 = int(nb4/2):N13 = nb4 - 2*nb5
    nb6 = int(nb5/2):N14 = nb5 - 2*nb6
    nb7 = int(nb6/2):N15 = nb6 - 2*nb7
    nb8 = int(nb7/2):N16 = nb7 - 2*nb8
    nb9 = int(nb8/2):N17 = nb8 - 2*nb9
    nb10 = int(nb9/2):N18 = nb9 - 2*nb10
    nb11 = int(nb10/2):N19 = nb10 - 2*nb11
    nb12 = int(nb11/2):N20 = nb11 - 2*nb12          'Bcounter bit 12 MSB
    N21 = 1    'Phase Det Current, 1= 1 ma, 0= 250 ua
    
if Dbug=1 then  print "parms for N buffer in [Command2326N] for PLL";CN;" LEPLL = ";LEPLL
    		parm$(0)=chr$(2)'  Command PLL SPI bus 
		    
		    parm$(1)=chr$(N21*2^7+N20*2^6+N19*2^5+N18*2^4+N17*2^3+N16*2^2+N15*2^1+N14*2^0)' Construct byte data to be sent to PIC
			parm$(2)=chr$(N13*2^7+N12*2^6+N11*2^5+N10*2^4+N9*2^3+N8*2^2+N7*2^1+N6*2^0)
		    parm$(3)=chr$(N5*2^7+N4*2^6+N3*2^5+N2*2^4+N1*2^3)
		    
		    if LEPLL=4   then   parm$(4)=chr$(1)' Command PLL1
		    if LEPLL=8   then   parm$(4)=chr$(2)' Command PLL2
		    if LEPLL=16 then   parm$(4)=chr$(3)' Command PLL3
		    
		    parm$(5)=chr$(200)' Delay between data pulses
		    parm$(6)=chr$(10)' Not used 
		    parm$(7)=chr$(10)' Not used 
		    parm$(8)=chr$(10)' Not used 
		    
		    parmDONE$=chr$(255)
		    
			for Parm=0 to 8
				if Dbug=1 then print asc(parm$(Parm));" ,  ";
				if PICRUN=1 then print #2,parm$(Parm);'PPPPPPPPPPPPPPPPPP[Command2326N]PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
				call Pause SERIALdelay 'Adjustable delay (in uS) between sending bytes to PIC
			next Parm
			
if Dbug=1 then print
if Dbug=1 then print asc(parmDONE$) 
if PICRUN=1 then print #2,parmDONE$;												'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
	
if Dbug=1 then 	print "rcounter = ";rcounter
if Dbug=1 then 	print "              2   1111   11111100000000    00  L"
if Dbug=1 then 	print "              0   9876   54321098765432    10  E"
if Dbug=1 then 	print "R    Buffer = ";r21;"   ";r20;r19;r18;r17;"   ";r16;r15;r14;r13;r12;r11;r10;r9;r8;r7;r6;r5;r4;r3;"    ";r2;r1;"  ";LEPLL;" ";0
if Dbug=1 then 	print
if Dbug=1 then 	print 

if Dbug=1 then print "ncounter = ";ncounter
if Dbug=1 then print "Acounter = ";Acounter
if Dbug=1 then print "Bcounter = ";Bcounter   
if Dbug=1 then print "              2   1111111111000   00000    00  L"
if Dbug=1 then print "              0   9876543210987   65432    10  E"

if Dbug=1 then print "N    Buffer = ";N21;"   ";N20;N19;N18;N17;N16;N15;N14;N13;N12;N11;N10;N9;N8;"   ";N7;N6;N5;N4;N3;"    ";N2;N1;"  ";LEPLL;" ";0
if Dbug=1 then print
if Dbug=1 then print
if Dbug=1 then print "------ N buffer written  for PLL";CN;"------------> ";

if Dbug=1 then input "N buffer written ====> ";xx$

ercount=0
[ECP6]

if PICRUN=0 then goto [picrun5]
	if Dbug=1 then print "Waiting for ack at [ECP6] (NBuffer) ercount= ";ercount
	if lof(#2) < 1 then goto [ECP6]
	dataRead$ = input$(#2, lof(#2))
	if left$(dataRead$ ,1) <> chr$(255) and Dbug=1 then
		print "NO ack at N buffer[ECP6]"
		gosub [printdataRead]
		input"----> ";xx$
	else
 		if Dbug=1 then print "ack received":print "=========================================="
	end if	
[picrun5]
return '[Command2326N]
'----------- N buffer done-----------


[CreateBaseForDDS]'needed:ddsoutput,ddsclock ; creates: base
    fullbase=(ddsoutput*2^32/ddsclock)
    base = int(fullbase) '32 bit frequency code in decimal
    overbase = fullbase-base
    if overbase>=.5 then base = base + 1
    return

'[ResetParallelDDS]'needed:control,wclkfqud,contclear ; resets DDS on J5, parallel
'=================================================My routine to reset AD9850 using the PIC based SERIAL control Board===================
 [initAD9850] 
  if Dbug=1 then input "entering [initAD9850] to  reset DDS1 and DDS3----------> ";xx$
 parm$(0)= chr$(7)				' command to reset DDS1 and DDS3
 parm$(1)=chr$(1)				'Dummy parm
 parm$(2)=chr$(2)
 parm$(3)=chr$(3)
 
 parmDONE$=chr$(255)	'terminate command
 
 if Dbug=1 then print "DDS reset parms in sub [initAD9850]    "

 	for parm=0 to 3
if Dbug=1 then print asc(parm$(parm))
if PICRUN=1 then print #2,parm$(parm);'PPPPPPPPPPPPPPPPPPPP[initAD9850]PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
	next parm

if Dbug=1 then print asc(parmDONE$)
if PICRUN=1 then print #2, parmDONE$;												'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
if Dbug=1 then print "Sequence of Pulse re-set pin, Write parallel word, Pulse re-set pin now complete "		
if Dbug=1 then input "------ reset DDS1 and DDS3 written ====> ";xx$:print

call Pause 10 
ercount=0

[ECP7]
ercount=ercount+1
if PICRUN=0 then goto [picrun4]
	if Dbug=1 then print "Waiting for ack at [ECP7] (initAD9850)  ercount= ";ercount
	if lof(#2) < 1 then goto [ECP7]
	dataRead$ = input$(#2, lof(#2))
	if left$(dataRead$ ,1) <> chr$(255) and Dbug=1 then
		print "NO ack at initAD9850 [ECP7]"
		gosub [printdataRead]
		input "----> ";xx$
 	else
 		if Dbug=1 then print "ack received":print "=========================================="
	end if

[picrun4]
return '[initad9850]

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
[DDS1command]'needed:base,word0,port,control,wclk,fqud,contclear ; commands DDS on J5, parallel

if PICRUN=1 then dataRead$ = input$(#2, lof(#2))'clean out serial read buffer
if Dbug=1 then print:print
call Pause 1
if Dbug=1 then input "Enter to write to  [DDS1command] ";xx$
if Dbug=1 then print "=============================    DDS1     frequency = ";ddsoutput;" MHz"
		word0 = 0   		'a "1" here will activate the x4 internal multiplier, but not recommended
        w1= int(base/2^24)  'w1 thru w4 converts decimal base code to 4 words, each are 8 bit binary
        w2= int((base-(w1*2^24))/2^16)
        w3= int((base-(w1*2^24)-(w2*2^16))/2^8)
        w4= int(base-(w1*2^24)-(w2*2^16)-(w3*2^8))
        
if Dbug=1 then print "parms for DDS1 "      
        parm$(0)=chr$(1)' Command DDS1
        parm$(1)=chr$(word0)'  5 8bit words
        parm$(2)=chr$(w1)
        parm$(3)=chr$(w2)
        parm$(4)=chr$(w3)
        parm$(5)=chr$(w4)
        parm$(6)=chr$(10)'  Delay for Data and WCLK (symetrical i.e W0 to DDS, delay, WCLK HI, delay, WCLK LO, delay, W1 to DDS ......   )
        parm$(7)=chr$(0)'		Not used
        parm$(8)=chr$(0)'		NOT used
        parmDONE$=chr$(255)
        
        for DDSParm=0 to 8
if Dbug=1 then print asc(parm$(DDSParm));"  ";
		call Pause SERIALdelay 'Adjustable delay (in uS) between sending bytes to PIC
if PICRUN=1 then  print #2,parm$(DDSParm);'PPPPPPPPPPPPPPPPPP[DDS1command]PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
        next DDSParm
        
if Dbug=1 then print asc(parmDONE$) 
if PICRUN=1 then print #2,parmDONE$;												'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
if Dbug=1 then print "wrote W0= ";word0; " W1= ";dechex$(w1);" W2= ";dechex$(w2);" W3= ";dechex$(w3);" W4= ";dechex$(w4)
if Dbug=1 then print "thisstep= ";thisstep
if Dbug=3 then print "thisstep= ";thisstep;"  ";

ercount=0
[ECP3]
ercount=ercount+1
if PICRUN=0 then goto [picrun3]
	if lof(#2) < 1 then goto [ECP3]			
 	dataRead$ = input$(#2, lof(#2))													'RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
	if left$(dataRead$ ,1) <> chr$(224) and Dbug=1 then
		print "NO ack at DDS1 [ECP3]"
		gosub [printdataRead]
		input"---->  ";xx$
	else
		if Dbug=1 then print "ack received":print "==================================="
	end if	
[picrun3]
call Pause 1
return' [DDS1command]
 
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
[CreateGraph]   'for Spectrum Analyzer
    WindowWidth = windowwide
    WindowHeight = graphhigh
    UpperLeftX = 1 'the Graph window upper left corner is 1 pixel right..
    UpperLeftY = 1 '...and 1 pixel down from the upper left of the screen
open "Graph Window for MSA/VNA, Spectrum Analyzer Mode - version 110" for graphics_nsb as #handle
    print #handle, "when leftButtonDown [LeftButDown]"
    print #handle, "when rightButtonDown [RightButDown]"
    print #handle, "trapclose [finished]"   'goto [finished] if xit is clicked
    print #handle, "down"       'ready to draw
    print #handle, "line ";0;" ";y;" ";x;" ";y              'draw baseline
    print #handle, "line ";" ";x/2;" ";y;" ";x/2;" ";y+10   'draw center tickmark
    ticks = abs(steps/10)
    for tick = 0 to ticks
    print #handle, "line ";" ";x*tick/ticks;" ";y;" ";x*tick/ticks;" ";y+5
    next tick       'this will draw a tickmark every 10 steps
    print #handle, "line ";0;" ";y-maxscale;" ";x;" ";y-maxscale  'draw a reference line for top power
    print #handle, "\";topref;" dBm"                    'print reference pwr level
    print #handle, "line ";0;" ";y-.9*maxscale;" ";x;" ";y-.9*maxscale
    print #handle, "\";topref - .1*(topref - botref);" dBm"
    print #handle, "line ";0;" ";y-.8*maxscale;" ";x;" ";y-.8*maxscale
    print #handle, "\";topref - .2*(topref - botref);" dBm"
    print #handle, "line ";0;" ";y-.7*maxscale;" ";x;" ";y-.7*maxscale
    print #handle, "\";topref - .3*(topref - botref);" dBm"
    print #handle, "line ";0;" ";y-.6*maxscale;" ";x;" ";y-.6*maxscale
    print #handle, "\";topref - .4*(topref - botref);" dBm"
    print #handle, "line ";0;" ";y-.5*maxscale;" ";x;" ";y-.5*maxscale
    print #handle, "\";topref - .5*(topref - botref);" dBm"
    print #handle, "line ";0;" ";y-.4*maxscale;" ";x;" ";y-.4*maxscale
    print #handle, "\";topref - .6*(topref - botref);" dBm"
    print #handle, "line ";0;" ";y-.3*maxscale;" ";x;" ";y-.3*maxscale
    print #handle, "\";topref - .7*(topref - botref);" dBm"
    print #handle, "line ";0;" ";y-.2*maxscale;" ";x;" ";y-.2*maxscale
    print #handle, "\";topref - .8*(topref - botref);" dBm"
    print #handle, "line ";0;" ";y-.1*maxscale;" ";x;" ";y-.1*maxscale
    print #handle, "\";topref - .9*(topref - botref);" dBm"
    print #handle, "line ";0;" ";y;" ";x;" ";y
    print #handle, "\";botref;" dBm"
    print #handle, "place 205 380"
    print #handle, "\  Center Frequency is:   "; centfreq; " MHz        Sweep Width is:    ";sweepwidth;" MHz"
    print #handle, "place 565 15"
    print #handle, "\  Max Power Input is:  "; maxpower-gain; " dBm"
    print #handle, "flush"      'make the graph lines stick
    return

[CreateGraphforVNA]   'for Vector Network Analyzer
'input "entered [CreateGraphforVNA] ";xx$
    WindowWidth = windowwide
    WindowHeight = graphhigh
    UpperLeftX = 1 'the Graph window upper left corner is 1 pixel right..
    UpperLeftY = 1 '...and 1 pixel down from the upper left of the screen
open "Graph Window for MSA/VNA, Vector Network Analyzer Mode - version 110" for graphics_nsb as #handle
    print #handle, "when leftButtonDown [LeftButDown]"
    print #handle, "when rightButtonDown [RightButDown]"
    print #handle, "trapclose [finished]"   'goto [finished] if xit is clicked
    print #handle, "down"       'ready to draw
    print #handle, "line ";0;" ";y;" ";x;" ";y              'draw baseline
    print #handle, "line ";" ";x/2;" ";y;" ";x/2;" ";y+10   'draw center tickmark
    ticks = abs(steps/10)
    for tick = 0 to ticks
    print #handle, "line ";" ";x*tick/ticks;" ";y;" ";x*tick/ticks;" ";y+5
    next tick       'this will draw a tickmark every 10 steps
    print #handle, "line ";0;" ";y-maxscale;" ";x;" ";y-maxscale  'draw a reference line for top power
    print #handle, "\";topref;" dB"                    'print reference pwr level
    print #handle, "line ";0;" ";y-.9*maxscale;" ";x;" ";y-.9*maxscale
    print #handle, "\";topref - .1*(topref - botref);" dB"
    print #handle, "line ";0;" ";y-.8*maxscale;" ";x;" ";y-.8*maxscale
    print #handle, "\";topref - .2*(topref - botref);" dB"
    print #handle, "line ";0;" ";y-.7*maxscale;" ";x;" ";y-.7*maxscale
    print #handle, "\";topref - .3*(topref - botref);" dB"
    print #handle, "line ";0;" ";y-.6*maxscale;" ";x;" ";y-.6*maxscale
    print #handle, "\";topref - .4*(topref - botref);" dB"
    print #handle, "line ";0;" ";y-.5*maxscale;" ";x;" ";y-.5*maxscale
    print #handle, "\";topref - .5*(topref - botref);" dB"
    print #handle, "line ";0;" ";y-.4*maxscale;" ";x;" ";y-.4*maxscale
    print #handle, "\";topref - .6*(topref - botref);" dB"
    print #handle, "line ";0;" ";y-.3*maxscale;" ";x;" ";y-.3*maxscale
    print #handle, "\";topref - .7*(topref - botref);" dB"
    print #handle, "line ";0;" ";y-.2*maxscale;" ";x;" ";y-.2*maxscale
    print #handle, "\";topref - .8*(topref - botref);" dB"
    print #handle, "line ";0;" ";y-.1*maxscale;" ";x;" ";y-.1*maxscale
    print #handle, "\";topref - .9*(topref - botref);" dB"
    print #handle, "line ";0;" ";y;" ";x;" ";y
    print #handle, "\";botref;" dB"
    print #handle, "place 205 380"
    print #handle, "\  Center Frequency is:   "; centfreq; " MHz        Sweep Width is:    ";sweepwidth;" MHz"
    print #handle, "place 565 15"
    print #handle, "\  Max Power Input is:  "; maxpower-gain; " dBm"
    print #handle, "place 2 40"
    print #handle, "color red"
    print #handle, "\";topphase;" Deg."
    print #handle, "place 2 320"
    print #handle, "\";botphase;" Deg."
    print #handle, "color black"
    print #handle, "flush"      'make the graph lines stick
    'input "returning from [CreateGraphforVNA] ";xx$
    return'[CreateGraphforVNA]

[Reprintlines]
    print #handle, "line ";0;" ";y-maxscale;" ";x;" ";y-maxscale  'draw a reference line for top power
    print #handle, "line ";0;" ";y-.9*maxscale;" ";x;" ";y-.9*maxscale
    print #handle, "line ";0;" ";y-.8*maxscale;" ";x;" ";y-.8*maxscale
    print #handle, "line ";0;" ";y-.7*maxscale;" ";x;" ";y-.7*maxscale
    print #handle, "line ";0;" ";y-.6*maxscale;" ";x;" ";y-.6*maxscale
    print #handle, "line ";0;" ";y-.5*maxscale;" ";x;" ";y-.5*maxscale
    print #handle, "line ";0;" ";y-.4*maxscale;" ";x;" ";y-.4*maxscale
    print #handle, "line ";0;" ";y-.3*maxscale;" ";x;" ";y-.3*maxscale
    print #handle, "line ";0;" ";y-.2*maxscale;" ";x;" ";y-.2*maxscale
    print #handle, "line ";0;" ";y-.1*maxscale;" ";x;" ";y-.1*maxscale
    print #handle, "line ";0;" ";y;" ";x;" ";y
    print #handle, "flush"      'make the graph lines stick
    return

[createWorkingWindow]'from [SetUpWorkingWindow]
    WindowWidth = 800'windowwide    'the Working window is 800 pixels wide
    WindowHeight = 180'windowhigh   'the Working window is 180 pixels in height
    UpperLeftX = 1    'the Working window upper left corner is 1 pixels right..
    UpperLeftY = 415  '...and 415 pixels down from the upper left corner of the monitor screen
    BackgroundColor$ = "darkblue"
    ForegroundColor$ = "white"
    statictext #main.message, "Message:", 5, 5, 50, 15
    statictext #main.finalif, "Final I.F.", 5, 65, 40, 12
    statictext #main.centerfreq, "Center Frequency", 323, 1, 120, 12
    statictext #main.centerfreq2, "MHz", 408, 18, 30, 12
    statictext #main.placemarkers, "Place Markers at Steps:", 598, 1, 120, 12
    statictext #main.topref, "Top Ref Line", 725, 1, 70, 12
    statictext #main.topref2, "dBm", 765, 18, 30, 12
    statictext #main.filter, "Select Final Filter:", 10, 25, 100, 12
    statictext #main.sweepwidth, "Sweep Width:", 320, 40, 80, 12
    statictext #main.sweepwidth2, "MHz", 383, 59, 30, 12
    statictext #main.stepspersweep, "Steps/Sweep", 415, 40, 80, 12
    statictext #main.stepspersweep2, "1-720", 460, 59, 40, 12
    statictext #main.mhzperstep, "MHz/Step:", 530, 40, 80, 12
    statictext #main.waittime, "Wait", 643, 40, 60, 12
    statictext #main.botref, "Bot Ref Line", 725, 40, 70, 12
    statictext #main.botref2, "dBm", 765, 59, 30, 12
    statictext #main.resolutionbw, "Res. B.W.", 5, 88, 50, 12
    statictext #main.hitanykey, "Hit any key", 5, 107, 80, 12
    statictext #main.hitanykey2, "on keyboard", 5, 120, 80, 12
    statictext #main.hitanykey3, "to Halt sweep", 5, 135, 80, 12
    statictext #main.thisstep, "Step", 235, 90, 50, 15
    statictext #main.thisfreq, "This Freq", 283, 90, 50, 15
    statictext #main.thispower, "Power (dBm)", 385, 90, 60, 15
    statictext #main.leftclick, "LeftClick", 170, 110, 50, 12
    statictext #main.rightclick, "RightClick", 170, 133, 50, 15
    TextboxColor$ = "red"   'the following textboxes will be red
    textbox #main.centerfreqbox, 325, 15, 80, 20 ' create Center Freq box
    textbox #main.marker1box, 600, 15, 30, 20  'create Marker box 1
    textbox #main.marker2box, 640, 15, 30, 20  'create Marker box 2
    textbox #main.marker3box, 680, 15, 30, 20  'create Marker box 3
    textbox #main.toprefbox, 725, 15, 35, 20 'create top reference line box
    textbox #main.sweepwidthbox, 325, 55, 55, 20 'create Sweep Width box
    textbox #main.stepspersweepbox, 420, 55, 35, 20 'create Steps per Sweep box
    textbox #main.waitbox, 640, 55, 35, 20 ' create Wait box
    textbox #main.botrefbox, 725, 55, 35, 20 'create bottom reference linebox
    textbox #main.hitkeybox, 85, 120, 30, 20  'create Hit any Key box
    TextboxColor$ = "blue"  'the following textboxes will be blue
    textbox #main.msgbox, 65, 3, 165, 20 ' create Message box
    textbox #main.finalifbox, 65, 62, 65, 20 ' create Final IF box
    textbox #main.resolutionbox, 65, 86, 65, 20 ' create Resolution BW box
    textbox #main.mhzperstepbox, 522, 55, 80, 20 'create MHz per step box
    textbox #main.stepnobox, 230, 106, 35, 20  'create step box
    textbox #main.thisfreqbox, 270, 106, 75, 20   'create This Freq box
    textbox #main.thispowerbox, 385, 106, 65, 20   'create Power box
    textbox #main.stepnobox2, 230, 130, 35, 20  'create step box
    textbox #main.thisfreqbox2, 270, 130, 75, 20   'create This Freq box
    textbox #main.thispowerbox2, 385, 130, 65, 20   'create Power box
    button #main.f1button, "F1", [button1], UL, 5, 38, 25, 20
    button #main.f2button, "F2", [button2], UL, 35, 38, 25, 20
    button #main.f3button, "F3", [button3], UL, 65, 38, 25, 20
    button #main.f4button, "F4", [button4], UL, 95, 38, 25, 20
    button #main.centerbutton, "Cent", [centerbutton], UL, 350, 106, 30, 20
    button #main.harmbutton, "Harmonic Window", [CreateHarmonicWindow], UL, 522, 80, 95, 20
    if PLL3 > 0 and trkgen = 0 then button #main.trkbutton, "Track Gen is OFF", [Trkbutton], UL, 522, 105, 95, 20
    if PLL3 > 0 and trkgen = 1 then button #main.trkbutton, "Track Gen is ON", [Trkbutton], UL, 522, 105, 95, 20
    button #main.spurbutton, "Spur Test is OFF", [Spurtest], UL, 522, 130, 95, 20
    button #main.rewrite, "REWRITE", [Rewrite], UL, 640, 80, 58, 20
    button #main.onestep, "ONESTEP", [OneStep], UL, 640, 105, 58, 20
    button #main.rewcont, "REW.CONT", [Rewcont], UL, 720, 80, 65, 20
    button #main.continue, "CONTINUE", [Continue], UL, 720, 105, 65, 20
    button #main.restart, "RESTART", [Restart], UL, 680, 130, 65, 20
    button #main.showvar, "Show Variables", [Showvar], UL, 150, 38, 80, 20
    if PLL3 > 0 then button #main.govna, "Go-VNA Mode", [GoVNAmode], UL, 150, 63, 80, 20
open "Working Window for MSA/VNA, Spectrum Analyzer Mode - version 110" for dialog as #main
    print #main, "trapclose [finished]" 'goto [finished] if xit is clicked
    print #main.finalifbox, "";finalfreq;" MHz"  'default final I.F. freq
    print #main.resolutionbox, "";finalbw;" KHz"  'default resolution BW
    print #main.centerfreqbox, "";centfreq    'default center freq
    print #main.sweepwidthbox, "";sweepwidth   'default sweep width
    print #main.stepspersweepbox, "";steps  'default steps per sweep
    print #main.marker1box, "";marker1     'insert marker1 default in Marker1 box
    print #main.marker2box, "";marker2     'insert marker2 default in Marker2 box
    print #main.marker3box, "";marker3     'insert marker3 default in Marker3 box
    print #main.waitbox, "";wate         'insert wate default in wait box
    print #main.toprefbox, "";topref    'insert default top reference line
    print #main.botrefbox, "";botref    'insert default bottom reference line
    if PICRUN=0 then print #main.msgbox,"Not Connected" else print #main.msgbox, "connected"
    return'[createWorkingWindow]

[createWorkingWindowforVNA]
    WindowWidth = windowwide    'the Working window is 800 pixels wide
    WindowHeight = windowhigh   'the Working window is 180 pixels in height
    UpperLeftX = 1    'the Working window upper left corner is 1 pixels right..
    UpperLeftY = 415  '...and 415 pixels down from the upper left corner of the monitor screen
    BackgroundColor$ = "darkred"
    ForegroundColor$ = "white"
    statictext #main.message, "Message:", 5, 5, 50, 15
    statictext #main.finalif, "Final I.F.", 5, 65, 40, 12
    statictext #main.centerfreq, "Center Frequency", 323, 1, 120, 12
    statictext #main.phasetop, "Phase Top", 245, 1, 60, 12
    statictext #main.phasetop2, "Deg.", 290, 18, 30, 15
    statictext #main.phasebot, "Phase Bot", 245, 40, 60, 12
    statictext #main.phasebot2, "Deg.", 290, 59, 30, 15
    statictext #main.centerfreq2, "MHz", 408, 18, 30, 12
statictext #main.pdminvert, "PDM Inversion", 450,18,80,15
    statictext #main.placemarkers, "Place Markers at Steps:", 598, 1, 120, 12
    statictext #main.topref, "Top Ref Line", 725, 1, 70, 12
    statictext #main.topref2, "dBc", 765, 18, 30, 12
    statictext #main.filter, "Select Final Filter:", 10, 25, 100, 12
    statictext #main.sweepwidth, "Sweep Width:", 320, 40, 80, 12
    statictext #main.sweepwidth2, "MHz", 383, 59, 30, 12
    statictext #main.stepspersweep, "Steps/Sweep", 415, 40, 80, 12
    statictext #main.stepspersweep2, "1-720", 460, 59, 40, 12
    statictext #main.mhzperstep, "MHz/Step:", 530, 40, 80, 12
    statictext #main.waittime, "Wait", 643, 40, 60, 12
    statictext #main.botref, "Bot Ref Line", 725, 40, 70, 12
    statictext #main.botref2, "dBc", 765, 59, 30, 12
    statictext #main.resolutionbw, "Res. B.W.", 5, 88, 50, 12
    statictext #main.hitanykey, "Hit any key", 5, 107, 80, 12
    statictext #main.hitanykey2, "on keyboard", 5, 120, 80, 12
    statictext #main.hitanykey3, "to Halt sweep", 5, 135, 80, 12
    statictext #main.thisstep, "Step", 235, 90, 50, 15
    statictext #main.thisfreq, "This Freq", 283, 90, 50, 15
    statictext #main.thispower, "Power (dBc)", 385, 90, 60, 15
    statictext #main.thisphase, "Phase", 460, 90, 50, 12
    statictext #main.leftclick, "LeftClick", 170, 110, 50, 12
    statictext #main.rightclick, "RightClick", 170, 133, 50, 15
    TextboxColor$ = "red"   'the following textboxes will be red
    textbox #main.phasetopbox, 255, 15, 35, 20 ' create Phase top line reference box
    textbox #main.phasebotbox, 255, 55, 35, 20 ' create Phase bottom line reference box
    textbox #main.centerfreqbox, 325, 15, 80, 20 ' create Center Freq box
textbox #main.invdegbox, 530, 15, 50, 20
    textbox #main.marker1box, 600, 15, 30, 20  'create Marker box 1
    textbox #main.marker2box, 640, 15, 30, 20  'create Marker box 2
    textbox #main.marker3box, 680, 15, 30, 20  'create Marker box 3
    textbox #main.toprefbox, 725, 15, 35, 20 'create top reference line box
    textbox #main.sweepwidthbox, 325, 55, 55, 20 'create Sweep Width box
    textbox #main.stepspersweepbox, 420, 55, 35, 20 'create Steps per Sweep box
    textbox #main.waitbox, 640, 55, 35, 20 ' create Wait box
    textbox #main.botrefbox, 725, 55, 35, 20 'create bottom reference linebox
    textbox #main.hitkeybox, 85, 120, 30, 20  'create Hit any Key box
    TextboxColor$ = "blue"  'the following textboxes will be blue
    textbox #main.msgbox, 65, 3, 165, 20 ' create Message box
    textbox #main.finalifbox, 65, 62, 65, 20 ' create Final IF box
    textbox #main.resolutionbox, 65, 86, 65, 20 ' create Resolution BW box
    textbox #main.mhzperstepbox, 522, 55, 80, 20 'create MHz per step box
    textbox #main.stepnobox, 230, 106, 35, 20  'create step box
    textbox #main.thisfreqbox, 270, 106, 75, 20   'create This Freq box
    textbox #main.thispowerbox, 385, 106, 65, 20   'create Power box
    textbox #main.thisphasebox, 455, 106, 60, 20   'create Phase box
    textbox #main.thisphasebox2, 455, 130, 60, 20   'create Phase box
    textbox #main.stepnobox2, 230, 130, 35, 20  'create step box
    textbox #main.thisfreqbox2, 270, 130, 75, 20   'create This Freq box
    textbox #main.thispowerbox2, 385, 130, 65, 20   'create Power box
    button #main.f1button, "F1", [button1], UL, 5, 38, 25, 20
    button #main.f2button, "F2", [button2], UL, 35, 38, 25, 20
    button #main.f3button, "F3", [button3], UL, 65, 38, 25, 20
    button #main.f4button, "F4", [button4], UL, 95, 38, 25, 20
    button #main.centerbutton, "Cent", [centerbutton], UL, 350, 106, 30, 20
    if trkgen = 0 then button #main.trkbutton, "Track Gen is OFF", [Trkbutton], UL, 522, 105, 95, 20
    if trkgen = 1 then button #main.trkbutton, "Track Gen is ON", [Trkbutton], UL, 522, 105, 95, 20
    button #main.rewrite, "REWRITE", [Rewrite], UL, 640, 80, 58, 20
    button #main.onestep, "ONESTEP", [OneStep], UL, 640, 105, 58, 20
    button #main.rewcont, "REW.CONT", [Rewcont], UL, 720, 80, 65, 20
    button #main.continue, "CONTINUE", [Continue], UL, 720, 105, 65, 20
    button #main.restart, "RESTART", [Restart], UL, 680, 130, 65, 20
    button #main.showvar, "Show Variables", [Showvar], UL, 150, 38, 80, 20
    button #main.gomsa, "Go-MSA Mode", [GoMSAmode], UL, 150, 63, 80, 20
    button #main.calibfwd, "Calibrate ?", [Calfwd], UL, 150, 86, 65, 20
open "Working Window for MSA/VNA, Vector Network Analyzer Mode - version 110" for dialog as #main
    print #main, "trapclose [finished]" 'goto [finished] if xit is clicked
    print #main.finalifbox, "";finalfreq;" MHz"  'default final I.F. freq
    print #main.resolutionbox, "";finalbw;" KHz"  'default resolution BW
    print #main.centerfreqbox, "";centfreq    'default center freq
    print #main.sweepwidthbox, "";sweepwidth   'default sweep width
    print #main.stepspersweepbox, "";steps  'default steps per sweep
    print #main.invdegbox,invdeg
    print #main.marker1box, "";marker1     'insert marker1 default in Marker1 box
    print #main.marker2box, "";marker2     'insert marker2 default in Marker2 box
    print #main.marker3box, "";marker3     'insert marker3 default in Marker3 box
    print #main.waitbox, "";1         'insert 1 in wait box when entering VNA mode. Slow down PDM
    print #main.toprefbox, "";topref    'insert default top reference line
    print #main.botrefbox, "";botref    'insert default bottom reference line
    print #main.phasetopbox,180
    print #main.phasebotbox,-180
    if PICRUN=0 then print #main.msgbox,"Not connected" else print #main.msgbox, "connected"
    return '[createWorkingWindowforVNA]

[GoMSAmode]
    vna = 0
    redim calarray(800,2)  'clear out the calibration array when changing to MSA mode
    close #main     'close out working window for VNA
    close #handle     'close out Graph window for VNA
    gosub [CreateGraph]
    gosub[createWorkingWindow]
    goto [Restart]

[GoVNAmode]
    vna = 1
    redim calarray(800,2)  'clear out the calibration array when changing to VNA mode
    close #main     'close out working window for SA
    close #handle     'close out Graph window for SA
'input "about to call [CreateGraphforVNA] ";xx$    
    gosub [CreateGraphforVNA]
'input "about to call    [createWorkingWindowforVNA] ";xx$ 
    gosub[createWorkingWindowforVNA]
    
'input "returned from  [createWorkingWindowforVNA] and goto [Restart] ";xx$   
    goto [Restart]

[calcWindowInfo]    'from [GrabWorkingWindowData]
'input "enterd [calcWindowInfo] from  [GrabWorkingWindowData] ";xx$
    print #main.centerfreqbox, "!contents? centfreq$";   'Center Freq box
    centfreq = val(centfreq$)    'change global to what user entered
    print #main.sweepwidthbox, "!contents? sweepwidth$";  'Sweep Width box
    sweepwidth = val(sweepwidth$)    'change global to what user entered
    print #main.stepspersweepbox, "!contents? steps$";   'Steps per Sweep box
    steps = val(steps$)    'change global to what user entered
    startfreq = centfreq - sweepwidth/2      'start frequency of sweep
    stepfreq = sweepwidth/steps   'delta step frequency
    print #main.mhzperstepbox, stepfreq  'MHz per step box
    print #main.marker1box, "!contents? mark1$";    'Marker1 box
    marker1 = val(mark1$)    'change global to what user entered
    print #main.marker2box, "!contents? mark2$";    'Marker2 box
    marker2 = val(mark2$)    'change global to what user entered
    print #main.marker3box, "!contents? mark3$";    'Marker3 box
    marker3 = val(mark3$)    'change global to what user entered
    print #main.waitbox, "!contents? wate$";        'Wait box
    wate = val(wate$)    'change global to what user entered
    print #main.toprefbox, "!contents? topref$";    'Top reference box
    topref = val(topref$)      'Log Det power, in dBm
    print #main.botrefbox, "!contents? botref$";   'Bottom reference box
    botref = val(botref$)      'Log Det power, in dBm
    if botref>=topref then botref = topref-10:print #main.botrefbox, "";topref-10
    if vna = 1 then print #main.invdegbox, "!contents? invdeg$";
    if vna = 1 then invdeg = val(invdeg$)
    if vna = 1 then print #main.phasetopbox, "!contents? topphasescale$";    'Top reference line from Phase Top box
    if vna = 1 then print #main.phasebotbox, "!contents? botphasescale$";    'Bot reference line from Phase Bot box
    if vna = 1 then topphase = val(topphasescale$)  'this is the phase of the top scale ref line
    if vna = 1 then botphase = val(botphasescale$)  'this is the phase of the bottom scale ref line
    if vna = 1 and botphase>=topphase then botphase = topphase-10:print #main.phasebotbox, "";botphase
    if vna = 1 then centphase = (topphase+botphase)/2  'this is the phase of the center scale ref line
'input "leaving [calcWindowInfo] and returning ";xx$    
    return      'goto [endGrabWorkingWindowData]

[LeftButDown] 'when left mouse button is pressed, do the following
    leftdownpixelx = MouseX
    if leftdownpixelx > x then leftdownpixelx=x
    leftstep = int(steps*leftdownpixelx/x)
    print #main.stepnobox,datatable(leftstep,0) 'display "thisstep" number from most current data
    print #main.thisfreqbox,datatable(leftstep,1) 'display "thisfreq" from most current data
    print #main.thispowerbox,datatable(leftstep,2) 'display "thispointpower" from most current data
    if vna = 1 then print #main.thisphasebox,datatable(leftstep,3);" deg" 'display phase measurement from most current data
    wait

[RightButDown] 'when right mouse button is pressed, do the following
    rightdownpixelx = MouseX
    if rightdownpixelx > x then rightdownpixelx=x
    rightstep = int(steps*rightdownpixelx/x)
    print #main.stepnobox2,datatable(rightstep,0) 'display "thisstep" number from most current data
    print #main.thisfreqbox2,datatable(rightstep,1) 'display "thisfreq" from most current data
    print #main.thispowerbox2,datatable(rightstep,2) 'display "thispointpower" from most current data
    if vna = 1 then print #main.thisphasebox2,datatable(rightstep,3);" deg" 'display phase measurement from most current data
    lowerfreq = datatable(leftstep,1)
    upperfreq = datatable(rightstep,1)
    if lowerfreq>upperfreq then lowerfreq=datatable(rightstep,1):upperfreq=datatable(leftstep,1)
    newsweepwidth = upperfreq-lowerfreq
    newcenterfreq = lowerfreq + newsweepwidth/2
    print #main.centerfreqbox, "";newcenterfreq
    print #main.sweepwidthbox, "";newsweepwidth
    wait

[centerbutton]'this will take the contents of the "This Freq" box and put it in the "Center Frequency" box
    print #main.thisfreqbox, "!contents? newcentfreq$"
    print #main.centerfreqbox, "";newcentfreq$
    wait

[Halted]   'from [DetermineNextOperation], Sweep has Halted, do the following
    gosub [Reprintlines]   'retrace graph lines when sweep is stopped
    print #main.msgbox,error$   'will print any error, when halted
print #main.msgbox,test
    print #main.stepnobox,thisstep
    print #main.thisfreqbox,thisfreq
    print #main.thispowerbox,thispointpower
    if vna = 1 then print #main.thisphasebox,phaseofpdm;" deg"
    wait    'wait until any button is clicked

[button1]
    finalfreq = finalfreq1
    finalbw = finalbw1
    gain = sagain1
   ' out port, 16: out control, enat:out control, contclear: out port, 0
    'the above line is an optional code for Final Xtal Filter relays:
    'Data 4 up, Init Printer up, Init Printer down, Data 4 down
    print #main.finalifbox, "";finalfreq;" MHz"
    print #main.resolutionbox, "";finalbw;" KHz"  'default resolution BW
    wait
[button2]
    finalfreq = finalfreq2
    finalbw = finalbw2
    gain = sagain2
   ' out port, 32: out control, enat:out control, contclear: out port, 0
    'Data 5 up, Init Printer up, Init Printer down, Data 5 down
    print #main.finalifbox, "";finalfreq;" MHz"
    print #main.resolutionbox, "";finalbw;" KHz"  'default resolution BW
    wait
[button3]
    finalfreq = finalfreq3
    finalbw = finalbw3
    gain = sagain3
 '   out port, 64: out control, enat:out control, contclear: out port, 0
    'Data 6 up, Init Printer up, Init Printer down, Data 6 down
    print #main.finalifbox, "";finalfreq;" MHz"
    print #main.resolutionbox, "";finalbw;" KHz"  'default resolution BW
    wait
[button4]
    finalfreq = finalfreq4
    finalbw = finalbw4
    gain = sagain4
'    out port, 128: out control, enat:out control, contclear: out port, 0
    'Data 7 up, Init Printer up, Init Printer down, Data 7 down
    print #main.finalifbox, "";finalfreq;" MHz"
    print #main.resolutionbox, "";finalbw;" KHz"  'default resolution BW
    wait

[Restart]
if Dbug=1 then print:input " entered [Restart] -------------------------> ";xx$
    close #handle   'close out graph window when restarting
    rewrite=0
    gosub [initAD9850] ' reset AD9850 with PIC based control Board ------------> (DDS1 AND DDS3 are re-set by the same command at the same time)
    print #main.hitkeybox, ""  'put "nothing" into HitAnyKey box
    print #main.hitkeybox, "!setfocus"  'make sure the "Hit any Key" box has the focus
'input "leaving [Restart] and about to   goto [GrabWorkingWindowData] "; xx$ 
    goto [GrabWorkingWindowData]

[Rewrite]
    rewrite=1
    goto [FocusKeyBox]

[Rewcont]
    rewrite=1
    goto [ClearKeyBox]

[OneStep]
    rewrite=0
    goto [FocusKeyBox]

[Continue]
    rewrite=0
    goto [ClearKeyBox]

[ClearKeyBox]
    print #main.hitkeybox, ""  'put "nothing" into HitAnyKey box

[FocusKeyBox]
    print #main.hitkeybox, "!setfocus"  'make sure the "Hit any Key" box has the focus
    goto [IncrementOneStep]

[Trkbutton]'needed:LO2,finalfreq,trkgen,PLL3off,rcounter3,masterclock
    if PLL3top = 0 then PLL3on = LO2 - finalfreq + PLL3offset
    if PLL3top = 1 then PLL3on = LO2 + thisfreq + PLL3offset
    if trkgen = 1 then print #main.trkbutton, "Track Gen is OFF":LO3 = PLL3off:gosub [ChangeTGfreq]:trkgen = 0:wait
    if trkgen = 0 then print #main.trkbutton, "Track Gen is ON":LO3 = PLL3on:gosub [ChangeTGfreq]:trkgen = 1:wait
[ChangeTGfreq]
    if PLL3top = 0 then gosub [ChangeFreqofPLL3old]
    if PLL3top = 1 then gosub [ChangeFreqofPLL3new]    
    return

[Spurtest]
    if spurcheck = 0 and PLL1mode = 0 then rcounter1=rcounter1+1:gosub[CommandPLL1R]
    if spurcheck = 0 then print #main.spurbutton, "Spur Test is ON":spurcheck=1:wait
    if spurcheck = 1 and PLL1mode = 0 then rcounter1=rcounter1-1:gosub[CommandPLL1R]
    if spurcheck = 1 then print #main.spurbutton, "Spur Test is OFF":spurcheck=0:wait

[CreateHarmonicWindow]
    if harmonicwindow = 1 then close #harmonicwindow: harmonicwindow = 0
    WindowWidth = 225    'the Harmonic Window is 800 pixels wide
    WindowHeight = 180   'the Harmonic Window is 180 pixels in height
    UpperLeftX = 1    'the Harmonic Window upper left corner is 1 pixels right..
    UpperLeftY = 1  '...and 1 pixels down from the upper left of the screen
    BackgroundColor$ = "darkblue"
    ForegroundColor$ = "white"
    image0 = thisfreq
    image1 = LO2 + finalfreq - LO1
    image2 = LO1 - finalfreq - LO2
    image3 = 2*LO2 - finalfreq - 2*LO1
    image4 = 2*LO2 + finalfreq - 2*LO1
    image5 = LO1 - 2*LO2 + finalfreq
    image6 = 2*LO1 - 2*LO2 - finalfreq
    button #harmonicwindow.image0button, "X", [Image0], UL, 2, 10, 15, 15
    statictext #harmonicwindow.image0text, "    LO1 - ThisFreq (";image0;") = LO2-FinalIF", 17, 10, 223, 20
    if image1 > 0 then button #harmonicwindow.image1button, "X", [Image1], UL, 2, 30, 15, 15
    statictext #harmonicwindow.image1text, "    LO1 + Image (";image1;") = LO2+FIF", 17, 30, 223, 20
    if image2 > 0 then button #harmonicwindow.image2button, "X", [Image2], UL, 2, 50, 15, 15
    statictext #harmonicwindow.image2text, "    LO1 - Image (";image2;") = LO2+FIF", 17, 50, 223, 20
    if image3 > 0 then button #harmonicwindow.image3button, "X", [Image3], UL, 2, 70, 15, 15
    statictext #harmonicwindow.image3text, "2xLO1 + Image (";image3;") = 2LO2-FIF", 17, 70, 223, 20
    if image4 > 0 then button #harmonicwindow.image4button, "X", [Image4], UL, 2, 90, 15, 15
    statictext #harmonicwindow.image4text, "2xLO1 + Image (";image4;") = 2LO2+FIF", 17, 90, 223, 20
    if image5 > 0 then button #harmonicwindow.image5button, "X", [Image5], UL, 2, 110, 15, 15
    statictext #harmonicwindow.image5text, "2xLO1 - Image (";image5;") = 2LO2-FIF", 17, 110, 223, 20
    if image6 > 0 then button #harmonicwindow.image6button, "X", [Image6], UL, 2, 130, 15, 15
    statictext #harmonicwindow.image6text, "2xLO1 - Image (";image6;") = 2LO2+FIF", 17, 130, 223, 20
    open "Harmonic Images" for dialog as #harmonicwindow
    harmonicwindow = 1
    print #harmonicwindow, "trapclose [CloseHarmonicWindow]" 'goto [CloseHarmonicWindow] if xit is clicked
    wait
[Image0]
    print #main.centerfreqbox, "";image0
    goto[Restart]
[Image1]
    print #main.centerfreqbox, "";image1
    goto[Restart]
[Image2]
    print #main.centerfreqbox, "";image2
    goto[Restart]
[Image3]
    print #main.centerfreqbox, "";image3
    goto[Restart]
[Image4]
    print #main.centerfreqbox, "";image4
    goto[Restart]
[Image5]
    print #main.centerfreqbox, "";image5
    goto[Restart]
[Image6]
    print #main.centerfreqbox, "";image6
    goto[Restart]
[CloseHarmonicWindow]
    close #harmonicwindow   'close out harmonicwindow
    harmonicwindow = 0
    wait

[Showvar]
    if varwindow=1 then goto [Closevarwin]
    WindowWidth = 200
    WindowHeight = 410
    UpperLeftX = 590
    UpperLeftY = 5
    BackgroundColor$ = "darkblue"
    ForegroundColor$ = "white"
    statictext #varwin.variable1, "ddsoutput = ";ddsoutput;" MHz", 5, 5, 180, 15
    statictext #varwin.variable2, "LO 1 = ";LO1;" MHz", 5, 20, 180, 15
    statictext #varwin.variable3, "pdf1 = ";pdf1;" MHz", 5, 35, 180, 15
    statictext #varwin.variable4, "ncount1 = ";ncount1, 5, 50, 180, 15
    statictext #varwin.variable5, "ncounter1 = ";ncounter1, 5, 65, 180, 15
    statictext #varwin.variable6, "Bcounter1 = ";Bcounter1, 5, 80, 180, 15
    statictext #varwin.variable7, "Acounter1 = ";Acounter1, 5, 95, 180, 15
    statictext #varwin.variable8, "fcounter1 = ";fcounter1, 5, 110, 180, 15
    statictext #varwin.variable9, "rcounter1 = ";rcounter1, 5, 125, 180, 15
    statictext #varwin.variable10, "LO2 = ";LO2;" MHz", 5, 140, 180, 15
    statictext #varwin.variable11, "pdf2 = ";pdf2;" MHz", 5, 155, 180, 15
    statictext #varwin.variable12, "ncounter2 = ";ncounter2, 5, 170, 180, 15
    statictext #varwin.variable13, "Bcounter2 = ";Bcounter2, 5, 185, 180, 15
    statictext #varwin.variable14, "Acounter2 = ";Acounter2, 5, 200, 180, 15
    statictext #varwin.variable15, "rcounter2 = ";rcounter2, 5, 215, 180, 15
    statictext #varwin.variable16, "LO3 = ";LO3;" MHz", 5, 230, 180, 15
    statictext #varwin.variable17, "pdf3 = ";pdf3;" MHz", 5, 245, 180, 15
    statictext #varwin.variable18, "ncounter3 = ";ncounter3, 5, 260, 180, 15
    statictext #varwin.variable19, "Bcounter3 = ";Bcounter3, 5, 275, 180, 15
    statictext #varwin.variable20, "Acounter3 = ";Acounter3, 5, 290, 180, 15
    statictext #varwin.variable21, "fcounter3 = ";fcounter3, 5, 305, 180, 15
    statictext #varwin.variable22, "rcounter3 = ";rcounter3, 5, 320, 180, 15
    statictext #varwin.variable23, "dds3output = ";dds3output, 5, 335, 180, 15
    statictext #varwin.variable24, "Mag AtoD Bits = ";magdata, 5, 350, 180, 15
    statictext #varwin.variable25, "Pha AtoD Bits = ";phadata;"     PDM = ";pdm, 5, 365, 180, 15
    open "Variables" for dialog as #varwin:varwindow = 1
    print #varwin, "trapclose [Closevarwin]" 'goto [Closevarwin] if xit is clicked
    print #main.showvar, "Close Variables"
    wait

[updatevar]
    print #varwin.variable1, "ddsoutput = ";ddsoutput;" MHz"
    print #varwin.variable2, "LO 1 = ";LO1;" MHz"
    print #varwin.variable3, "pdf1 = ";pdf1;" MHz"
    print #varwin.variable4, "ncount1 = ";ncount1
    print #varwin.variable5, "ncounter1 = ";ncounter1
    print #varwin.variable6, "Bcounter1 = ";Bcounter1
    print #varwin.variable7, "Acounter1 = ";Acounter1
    print #varwin.variable8, "fcounter1 = ";fcounter1
    print #varwin.variable9, "rcounter1 = ";rcounter1
    print #varwin.variable10, "LO2 = ";LO2;" MHz"
    print #varwin.variable11, "pdf2 = ";pdf2;" MHz"
    print #varwin.variable12, "ncounter2 = ";ncounter2
    print #varwin.variable13, "Bcounter2 = ";Bcounter2
    print #varwin.variable14, "Acounter2 = ";Acounter2
    print #varwin.variable15, "rcounter2 = ";rcounter2
    print #varwin.variable16, "LO3 = ";LO3;" MHz"
    print #varwin.variable17, "pdf3 = ";pdf3;" MHz"
    print #varwin.variable18, "ncounter3 = ";ncounter3
    print #varwin.variable19, "Bcounter3 = ";Bcounter3
    print #varwin.variable20, "Acounter3 = ";Acounter3
    print #varwin.variable21, "fcounter3 = ";fcounter3
    print #varwin.variable22, "rcounter3 = ";rcounter3
    print #varwin.variable23, "dds3output = ";dds3output
    print #varwin.variable24, "Mag AtoD Bits = ";magdata
    print #varwin.variable25, "Pha AtoD Bits = ";phadata;"     PDM = ";pdm
    return

[Closevarwin]
    close #varwin:varwindow = 0     'close out variables window
    print #main.showvar, "Show Variables"
    wait
'======================================================================================================
'=======================================================================================================
'====================================PLL3 control========================================================
[CreateRcounterPLL3old]'needed:masterclock,PLL3phasefreq ; creates:rcounter3,pdf3
    rcounter3 = int(masterclock/PLL3phasefreq)
    if (masterclock/PLL3phasefreq) - rcounter3 >= .5 then rcounter3 = rcounter3 + 1   'rounds off rcounter3
    pdf3 = masterclock/rcounter3    'actual phase detector frequency of PLL 3
    return 'with:rcounter3,pdf3
    
[CreateRcounterPLL3new]'needed:appxDDS3,dds3filbw,PLL3phasefreq ; creates:rcounter3
    rcounter3 = int((appxDDS3 + (.5*dds3filbw))/PLL3phasefreq)  'This determines the whole number Reference divide ratio for PLL 3
    if ((appxDDS3 + (.5*dds3filbw))/PLL3phasefreq) - rcounter3 >= .5 then rcounter3 = rcounter3 +1
    return 'with:rcounter3
    
[ChangeFreqofPLL3old]'needed:LO3,rcounter3,masterclock ; changes PLL3 freq : creates:ncounter3,fcounter3
if Dbug=1 then print "Changing PLL3OLD frequency to ";LO3
    appxVCO = LO3
    reference = masterclock
    rcounter = rcounter3
    if PLL3mode = 0 then gosub [CreateIntegerNcounter]'needs:appxVCO,reference,rcounter ; creates:ncounter,fcounter(0)
'    if PLL3mode = 1 then gosub [CreateFractionalNcounter]'needs:appxVCO,reference,rcounter ; creates:ncounter,fcounter
    ncounter3 = ncounter : fcounter3 = fcounter
if Dbug=1 then print "in [ChangeFreqofPLL3old] and calling [CommandPLL3N]"
    gosub [CommandPLL3N]'needs:ncounter,fcounter,PLL1mode,enat,PLL3
    Bcounter3=Bcounter: Acounter3=Acounter
    LO3=((Bcounter*preselector)+Acounter+(fcounter/16))*pdf3 'actual LO3 frequency
    return

[ChangeFreqofPLL3new]'needed:LO3,rcounter3,appxDDS3,enat ; commands PLL3 Ncounters ; creates:ncounter3,fcounter3(0),dds3output,pdf3
if Dbug=1 then print "changing PLL3NEW frequency to ";LO3
    if LO3 = lastLO3 then return  'don't waste time commanding, if not needed
    lastLO3 = LO3
    Jcontrol=enat : swclk=32 : sfqudsfqud=2
    gosub [CreateNcounter3andDDS3output]'needs:LO3,rcounter3,appxDDS3 ; creates:ncounter3,fcounter3(0),dds3output,base
    gosub [DDS3command]'needed:port,control,base,Jcontrol,swclk,sfqud,contclear ; commands DDS, serially
    ncounter=ncounter3 : fcounter=fcounter3
    if ncounter3 = lastncounter3 then return
    lastncounter3 = ncounter3
    gosub [CommandPLL3N]'needed:ncounter,fcounter,PLL3mode,enat,PLL3
    Bcounter3=Bcounter: Acounter3=Acounter
    return

[CreateNcounter3andDDS3output]'needed:LO3,rcounter3,appxDDS3 ; creates:ncounter3,fcounter3,dds3output,base
    ncount3 = LO3/(appxDDS3/rcounter3)  'approximates the Ncount for PLL 3/DDS3
    ncounter3 = int(ncount3)    'actual value for PLL3 Ncounter
    if ncount3 - ncounter3 >= .5 then ncounter3 = ncounter3 + 1
    fcounter3 = 0
    pdf3 = LO3/ncounter3        'actual phase freq of PLL3
    dds3output = pdf3 * rcounter3    'actual output of DDS3(input Ref to PLL3)
    fullbase=(dds3output*2^32/masterclock)
    base = int(fullbase) '32 bit frequency code in decimal
    overbase = fullbase-base
    if overbase>=.5 then base = base + 1
    return 'with ncounter3,fcounter3,dds3output,base

[DDS3command]'needed:port,control,base,Jcontrol,swclk,sfqud,contclear ; commands DDS, serially
if Dbug=1 then input "entering [DDS3Command]  to program DDS3----------> ";xx$
    if base = lastbase4 then return

if Dbug=1 then print "=============================    DDS3     frequency = ";dds3output;" MHz"
        w1= int(base/2^24)  'w1 thru w4 converts decimal base code to 4 words, each are 8 bit binary
        w2= int((base-(w1*2^24))/2^16)
        w3= int((base-(w1*2^24)-(w2*2^16))/2^8)
        w4= int(base-(w1*2^24)-(w2*2^16)-(w3*2^8))
if Dbug=1 then print "parms for DDS3 in  [DDS3command]"       
        parm$(0)=chr$(3)' Command DDS3
        parm$(1)=chr$(word0)'  5 8bit words
        parm$(2)=chr$(w1)
        parm$(3)=chr$(w2)
        parm$(4)=chr$(w3)
        parm$(5)=chr$( w4)
        parm$(6)=chr$(100)'  Delay for Data and WCLK (symetrical i.e W0 to DDS, delay, WCLK HI, delay, WCLK LO, delay, W1 to DDS ......   )
        parm$(7)=chr$(0)'		Not used
        parm$(8)=chr$(0)'		NOT used
        parmDONE$=chr$(255)
        
        for Parm=0 to 8
        call Pause SERIALdelay 'Adjustable delay (in uS) between sending bytes to PIC
if Dbug=1 then print asc(parm$(Parm))
if PICRUN=1 then print #2,parm$(Parm);'PPPPPPPPPPPPPPPP[DDS3command]PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
        next Parm
        
if Dbug=1 then print asc(parmDONE$) 
if PICRUN=1 then print #2,parmDONE$;												'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
 		
if Dbug=1 then print "wrote W0= ";word0; " W1= ";dechex$(w1);" W2= ";dechex$(w2);" W3= ";dechex$(w3);" W4= ";dechex$(w4)

ercount=0

[ECP2]
ercount=ercount+1
if PICRUN=0 then goto [picrun2]
	if Dbug=1 then print "Waiting for ack at [ECP2] (DDS3 command) ercount = ";ercount
	if lof(#2) < 1 then goto [ECP2]
	
 	dataRead$ = input$(#2, lof(#2))
 	if left$(dataRead$ ,1) <> chr$(255) and Dbug=1 then
 		print "NO ack at DDS3 [ECP2]"
 		gosub [printdataRead]
 		input"----> ";xx$
 	else
 		if Dbug=1 then print "ack received"
 	end if	
[picrun2]
   return '[DDS3command]


[Calfwd]
    calfwd = 1
    pdm = 0 'begin the cal with the PDM set to "Normal", for proper
    print #main.calibfwd, "Calibrating"
    goto [Restart]

[finished]
    close #main     'close out working window
    close #handle   'close out graph window
if PICRUN=1 then close #2			'close serial port								'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
    if harmonicwindow = 1 then close #harmonicwindow   'close out harmonicwindow
    if varwindow = 1 then close #varwin   'close out variable window
    end
'------------
    '   The following are error messages and are not compiled:
    '   "DDSoutput too high for filter" decrease global variable, PLL1phasefreq or widen DDS output filter
    '   "DDSoutput too low for filter" decrease global variable, PLL1phasefreq or widen DDS output filter
    '   "2325 Rcounter is < 3"
    '   "2325 Rcounter is > 16383"
    '   "2325 Bcounter < 3"
    '   "2325 Bcounter > 2047"
    '   "2325 Bcounter<Acounter"
    '   "2326 R counter <3"
    '   "2326 R counter >16383"
    '   "2326 B counter <3"
    '   "2326 B counter >8191"
    '   "2326 B counter<Acounter"
    '   "2350 Rcounter <3"
    '   "2350 Rcounter >32767"
    '   "2350 Rcounter <3"
    '   "2350 Rcounter >1023"
    '   "2350 Bcounter<Acounter+2"
    '   "2353 Rcounter is < 3"
    '   "2353 Rcounter is > 32767"
    '   "2353 Bcounter is < 3"
    '   "2353 Bcounter is > 1023"
    '   "2353 Bcounter < Acounter+1"
'when the sweep is Halted:
'at the point where it is halted, the last step's data is shown in the
'    (LeftClick) "Step", "This Freq", "Power", and "Phase" boxes
'place the mouse pointer on the graph and click the left Mouse button, will grab the closest step and change
    'the (LeftClick) "Step", "This Freq", "Power", and "Phase" boxes to the data that was taken last.
'place the mouse pointer on the graph and click the right Mouse button, will grab the closest step and:
    '1. calculate the frequency difference from the previous left Mouse click and place it in the "Sweep Width" box.
    '2. calculate the center frequency of the two points and place it in the "Center Frequency" box.
    '3. wait for a "RESTART", which will then begin a new sweep with the new "Center Frequency" and "Sweep Width"
'Click the "Cent" button, will install the "This Freq" box data, into the "Center Frequency" box.
'Click the "Show Variables" button, will open a small window, displaying the variables being used in the program.
'Click the "Track Gen is OFF" button, will command the Tracking Generator to the frequency at which the
'  sweep is halted.  The button will change to "Track Gen is ON".  Click button again, will command the Tracking
'  Generator to the "PLL3off" frequency, which is 970 MHz.

'    To see linearity of PDM (where the indeterminate zone is):
'    Install 4 foot cable from TG out (Mag Ref out)
'    find this line of code and make it a "remark" by inserting a ' at the beginning of the line:
'    "if phadata/maxpdmout < .2 or phadata/maxpdmout > .8 then gosub [InvertPDmodule]"
'    do not click "Calibrate ?"
'    Sweep wide enough to get at least one full ramp.  The plot will show the unlinearity around 0 degrees.
'    My zone is from -20 degrees to + 30 degrees. Using 80% to 20% in software = -72 deg to +72 deg



'===========================================================================================
[OpenCOM]' Sub to open serial port and establish communication with the PIC
'baud=115200
'parity=N for no parity
'data= 8 bits
'1 stop bit
'CS=0  CTS (Clear To Send) has 0 timeout
'RS means --> disable DISABLE RTS (Request To Send) i.e. don't wait for RTS line to be high before transmitting to PIC
'By default: DTR (Data Terminal Ready) is disabled
'                  XON/XOFF (software handshaking) is disabled
'                  Binary Mode is enabled (i.e. 8 data bits - NO trunaction to 7 bits!!!!!)
if Dbug=1 then input "OpenCOM next "; xx$
Com=16384

	WindowWidth = 300'windowwide    'the Working window is 800 pixels wide
    WindowHeight = 100'windowhigh   'the Working window is 180 pixels in height
    UpperLeftX = 1    'the Working window upper left corner is 1 pixels right..
    UpperLeftY = 100 '...and 100 pixels down from the upper left corner of the monitor screen
    BackgroundColor$ = "darkblue"
    ForegroundColor$ = "white"
	statictext #connect.message, "Connect to Control Board", 5, 5, 190, 15
    button #connect.f1button, "Connect", [button99], UL, 30, 38, 100, 30
open "Spectrum Analyzer V120" for dialog as #connect

wait
[button99]
close #connect     'close out working window

open PICcom$+":115200,N,8,1,ds0,CS0,RS" for random as #2			'RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
if Dbug=1 then input "after open statement "; xx$

print #2,"U";	'initialize PIC Baudrate as specified in the OPEN COM statement
call Pause 10
dataRead$ = input$(#2, lof(#2))									
if Dbug=1 then print "going sub printDataRead ":gosub [printdataRead]

'Establish communications with PIC
 print #2,"R";		'tell PIC to connect
 ercount=0

'---------- 
[ECP1]'								loop here 100 times to check if connected
 	call Pause 10
	if Dbug=1 then input "at [ECP1] ==> ";xx$
	ercount=ercount+1
	if Dbug=1 then print"waiting for input from PIC ---> ercount= ";ercount
 	if ercount > 2 then				'exceeded re-try count - so no connection
 		close #2'close com handle
 		if Dbug=1 then print "can't connect"
 		c$="Can't connect"+chr$(13)				'Message window to ask if TRY AGAIN
 		c$ = c$ + "try again "+chr$(13)
 		confirm c$; answer$
        if answer$ = "no" then end 				'If answer is NO the end the program
 		goto [OpenCOM]							'If answer is YES then try again
	end if
if lof(#2) < 1 then goto [ECP1]'	if no resonse from PIC check again
'-----------

'---------------DATA received from PIC   NOW check if it is what it should be --- a "2"----------
 	if Dbug=1 then print "data received from PIC ---> ";lof(#2);" bytes"
 	dataRead$ = input$(#2, lof(#2))
 	if Dbug=1 then gosub [printdataRead]
	if left$(dataRead$,1)<>"2" then notice "Communication ERROR"+chr$(13)+"Communication with Control Board"+chr$(13)+" corrupted  -  restart program"
	if left$(dataRead$,1)<>"2" then end

[exitOpenCOM]
	if Dbug=1 then input "Enter to return from [OpenCOM] ----------> ";xx$
	

return '[OpenCOM]
'===========================================================================================
'===========================================================================================

Sub Pause uS
'call Pause, 1000
OneMicroSecondSTEPS=272
if OneMicroSecondSTEPS =0 	then
							Print "calibrating"
							k=2000000
							starttime=time$("milliseconds")
							for j=1 to k:next j
							endtime=time$("milliseconds")
							elapsedtime=endtime-starttime
							OneMicroSecondSTEPS=int(k/elapsedtime)
							end if
for j=1 to uS*OneMicroSecondSTEPS :next j
'print "OneMicroSecondSTEPS = ";OneMicroSecondSTEPS
End Sub 
'===========================================================================================
'===========================================================================================
[CheckDataError]' Sub to print out data errors from serial interface
'print #main.msgbox,".";
return

'if ercount < 99 then print pos$;:return 
'print "Com error in ";pos$

'input "Enter to STOP program";xx$
'	close #main     'close out working window
'    close #handle   'close out graph window
'if PICRUN=1 then close #2			'close serial port									'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
'    if harmonicwindow = 1 then close #harmonicwindow   'close out harmonicwindow
'    if varwindow = 1 then close #varwin   'close out variable window
'end
'===========================================================================================

[printdataRead]
if Dbug <> 1 then return
for xx=1 to len(dataRead$):print asc(mid$ (dataRead$,xx,1));:print" ";:next xx:print
return

'===========================================================================================
[handleCOMerror]
input "enter [handleCOMerror]>   ";xx$
    'disable the com error handler
    'oncomerror

    'print out the error and port
    
'    print #main.msgbox,"Com error"
'    print #main.msgbox,ComError$

    print "Error: "; ComError$
    print "Port number: "; ComPortNumber
    print "Error code: ";ComErrorNumber

  
if PICRUN=1 then close #2					'PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
PICRUN=0
return












